/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         htwolcpre3parse
#define yylex           htwolcpre3lex
#define yyerror         htwolcpre3error
#define yydebug         htwolcpre3debug
#define yynerrs         htwolcpre3nerrs
#define yylval          htwolcpre3lval
#define yychar          htwolcpre3char

/* First part of user prologue.  */
#line 13 "htwolcpre3-parser.yy"

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#ifdef WINDOWS
#include <io.h>
#endif

#include <iostream>
#include <fstream>
#include <cstdlib>
#include "io_src/InputReader.h"
#include "grammar_defs.h"
#include "HfstTwolcDefs.h"
#include "rule_src/TwolCGrammar.h"
#include "rule_src/OtherSymbolTransducer.h"
#include "alphabet_src/Alphabet.h"
#include "string_src/string_manipulation.h"
#include <cstdio>

#ifdef DEBUG_TWOLC_3_GRAMMAR
#define YYDEBUG 1
#endif

  extern int htwolcpre3lineno;
  extern char * htwolcpre3text;
  extern int htwolcpre3lineno;
  extern char * htwolcpre3text;
  void htwolcpre3error(const char * text );
  void htwolcpre3_semantic_error(const char * text);
  void htwolcpre3warn(const char * warning );
  void htwolcpre3message(const std::string &m);
  int htwolcpre3lex();
  int htwolcpre3parse();
  
  bool silent_ = false;
  bool verbose_ = false;

namespace hfst {
  namespace twolcpre3 {
  void set_silent(bool val)
  {
    silent_ = val;
  }
  void set_verbose(bool val)
  {
    verbose_ = val;
  }
  int parse()
  {
    return htwolcpre3parse();
  }
  void message(const std::string &m)
  {
    return htwolcpre3message(m);
  }
}}

#define YYERROR_VERBOSE 1

  // For reading input one byte at a time.
  size_t htwolcpre3_line_number = 1;
  InputReader htwolcpre3_input_reader(htwolcpre3_line_number);

namespace hfst { namespace twolcpre3 {

  void set_input(std::istream & istr)
  {
    htwolcpre3_input_reader.set_input(istr);
  }
  void set_warning_stream(std::ostream & ostr)
  {
    htwolcpre3_input_reader.set_warning_stream(ostr);
  }
  void set_error_stream(std::ostream & ostr)
  {
    htwolcpre3_input_reader.set_error_stream(ostr);
  }

}}

#ifdef HAVE_XFSM
  #define Alphabet TwolCAlphabet
#endif

  // The Alphabet of the grammar
  Alphabet alphabet;

  // A map storing named regular expressions (i.e. definitions).
  HandyMap<std::string,OtherSymbolTransducer> definition_map;

  // The grammar, which compiles rules, resolves conflicts and stores
  // rule transducers.
  // TwolCGrammar grammar(true,true);
  TwolCGrammar * grammar;

namespace hfst {
  namespace twolcpre3 {
  void set_grammar(TwolCGrammar * grammar_)
  {
    grammar = grammar_;
  }
  TwolCGrammar * get_grammar()
  {
    return grammar;
  }

  void reset_parser()
  {
    htwolcpre3_line_number = 1;
    htwolcpre3_input_reader.reset();
    alphabet = Alphabet();
    definition_map = HandyMap<std::string,OtherSymbolTransducer>();
  }

}}

  unsigned int get_number(const std::string &);
  unsigned int get_second_number(const std::string &s);
  std::string get_name(const std::string &s);


#line 202 "htwolcpre3-parser.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_HTWOLCPRE3_HTWOLCPRE_PARSER_HH_INCLUDED
# define YY_HTWOLCPRE3_HTWOLCPRE_PARSER_HH_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int htwolcpre3debug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    FREELY_INSERT = 258,           /* FREELY_INSERT  */
    DIFFERENCE = 259,              /* DIFFERENCE  */
    INTERSECTION = 260,            /* INTERSECTION  */
    UNION = 261,                   /* UNION  */
    STAR = 262,                    /* STAR  */
    PLUS = 263,                    /* PLUS  */
    CONTAINMENT = 264,             /* CONTAINMENT  */
    CONTAINMENT_ONCE = 265,        /* CONTAINMENT_ONCE  */
    TERM_COMPLEMENT = 266,         /* TERM_COMPLEMENT  */
    COMPLEMENT = 267,              /* COMPLEMENT  */
    POWER = 268,                   /* POWER  */
    RIGHT_SQUARE_BRACKET = 269,    /* RIGHT_SQUARE_BRACKET  */
    RIGHT_PARENTHESIS = 270,       /* RIGHT_PARENTHESIS  */
    LEFT_SQUARE_BRACKET = 271,     /* LEFT_SQUARE_BRACKET  */
    LEFT_PARENTHESIS = 272,        /* LEFT_PARENTHESIS  */
    LEFT_RESTRICTION_ARROW = 273,  /* LEFT_RESTRICTION_ARROW  */
    LEFT_ARROW = 274,              /* LEFT_ARROW  */
    RIGHT_ARROW = 275,             /* RIGHT_ARROW  */
    LEFT_RIGHT_ARROW = 276,        /* LEFT_RIGHT_ARROW  */
    RE_LEFT_RESTRICTION_ARROW = 277, /* RE_LEFT_RESTRICTION_ARROW  */
    RE_LEFT_ARROW = 278,           /* RE_LEFT_ARROW  */
    RE_RIGHT_ARROW = 279,          /* RE_RIGHT_ARROW  */
    RE_LEFT_RIGHT_ARROW = 280,     /* RE_LEFT_RIGHT_ARROW  */
    RE_RIGHT_SQUARE_BRACKET = 281, /* RE_RIGHT_SQUARE_BRACKET  */
    RE_LEFT_SQUARE_BRACKET = 282,  /* RE_LEFT_SQUARE_BRACKET  */
    ALPHABET_DECLARATION = 283,    /* ALPHABET_DECLARATION  */
    DIACRITICS_DECLARATION = 284,  /* DIACRITICS_DECLARATION  */
    SETS_DECLARATION = 285,        /* SETS_DECLARATION  */
    DEFINITION_DECLARATION = 286,  /* DEFINITION_DECLARATION  */
    RULES_DECLARATION = 287,       /* RULES_DECLARATION  */
    COLON = 288,                   /* COLON  */
    SEMI_COLON = 289,              /* SEMI_COLON  */
    EQUALS = 290,                  /* EQUALS  */
    CENTER_MARKER = 291,           /* CENTER_MARKER  */
    QUESTION_MARK = 292,           /* QUESTION_MARK  */
    EXCEPT = 293,                  /* EXCEPT  */
    RULE_NAME = 294,               /* RULE_NAME  */
    SYMBOL = 295,                  /* SYMBOL  */
    DEFINITION_NAME = 296,         /* DEFINITION_NAME  */
    NUMBER = 297,                  /* NUMBER  */
    NUMBER_RANGE = 298             /* NUMBER_RANGE  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define FREELY_INSERT 258
#define DIFFERENCE 259
#define INTERSECTION 260
#define UNION 261
#define STAR 262
#define PLUS 263
#define CONTAINMENT 264
#define CONTAINMENT_ONCE 265
#define TERM_COMPLEMENT 266
#define COMPLEMENT 267
#define POWER 268
#define RIGHT_SQUARE_BRACKET 269
#define RIGHT_PARENTHESIS 270
#define LEFT_SQUARE_BRACKET 271
#define LEFT_PARENTHESIS 272
#define LEFT_RESTRICTION_ARROW 273
#define LEFT_ARROW 274
#define RIGHT_ARROW 275
#define LEFT_RIGHT_ARROW 276
#define RE_LEFT_RESTRICTION_ARROW 277
#define RE_LEFT_ARROW 278
#define RE_RIGHT_ARROW 279
#define RE_LEFT_RIGHT_ARROW 280
#define RE_RIGHT_SQUARE_BRACKET 281
#define RE_LEFT_SQUARE_BRACKET 282
#define ALPHABET_DECLARATION 283
#define DIACRITICS_DECLARATION 284
#define SETS_DECLARATION 285
#define DEFINITION_DECLARATION 286
#define RULES_DECLARATION 287
#define COLON 288
#define SEMI_COLON 289
#define EQUALS 290
#define CENTER_MARKER 291
#define QUESTION_MARK 292
#define EXCEPT 293
#define RULE_NAME 294
#define SYMBOL 295
#define DEFINITION_NAME 296
#define NUMBER 297
#define NUMBER_RANGE 298

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 140 "htwolcpre3-parser.yy"

  int symbol_number;
  OtherSymbolTransducer * regular_expression;
  char * value;
  SymbolRange * symbol_range;
  SymbolPairVector * symbol_pair_range;
  op::OPERATOR rule_operator;

#line 350 "htwolcpre3-parser.cc"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE htwolcpre3lval;


int htwolcpre3parse (void);


#endif /* !YY_HTWOLCPRE3_HTWOLCPRE_PARSER_HH_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_FREELY_INSERT = 3,              /* FREELY_INSERT  */
  YYSYMBOL_DIFFERENCE = 4,                 /* DIFFERENCE  */
  YYSYMBOL_INTERSECTION = 5,               /* INTERSECTION  */
  YYSYMBOL_UNION = 6,                      /* UNION  */
  YYSYMBOL_STAR = 7,                       /* STAR  */
  YYSYMBOL_PLUS = 8,                       /* PLUS  */
  YYSYMBOL_CONTAINMENT = 9,                /* CONTAINMENT  */
  YYSYMBOL_CONTAINMENT_ONCE = 10,          /* CONTAINMENT_ONCE  */
  YYSYMBOL_TERM_COMPLEMENT = 11,           /* TERM_COMPLEMENT  */
  YYSYMBOL_COMPLEMENT = 12,                /* COMPLEMENT  */
  YYSYMBOL_POWER = 13,                     /* POWER  */
  YYSYMBOL_RIGHT_SQUARE_BRACKET = 14,      /* RIGHT_SQUARE_BRACKET  */
  YYSYMBOL_RIGHT_PARENTHESIS = 15,         /* RIGHT_PARENTHESIS  */
  YYSYMBOL_LEFT_SQUARE_BRACKET = 16,       /* LEFT_SQUARE_BRACKET  */
  YYSYMBOL_LEFT_PARENTHESIS = 17,          /* LEFT_PARENTHESIS  */
  YYSYMBOL_LEFT_RESTRICTION_ARROW = 18,    /* LEFT_RESTRICTION_ARROW  */
  YYSYMBOL_LEFT_ARROW = 19,                /* LEFT_ARROW  */
  YYSYMBOL_RIGHT_ARROW = 20,               /* RIGHT_ARROW  */
  YYSYMBOL_LEFT_RIGHT_ARROW = 21,          /* LEFT_RIGHT_ARROW  */
  YYSYMBOL_RE_LEFT_RESTRICTION_ARROW = 22, /* RE_LEFT_RESTRICTION_ARROW  */
  YYSYMBOL_RE_LEFT_ARROW = 23,             /* RE_LEFT_ARROW  */
  YYSYMBOL_RE_RIGHT_ARROW = 24,            /* RE_RIGHT_ARROW  */
  YYSYMBOL_RE_LEFT_RIGHT_ARROW = 25,       /* RE_LEFT_RIGHT_ARROW  */
  YYSYMBOL_RE_RIGHT_SQUARE_BRACKET = 26,   /* RE_RIGHT_SQUARE_BRACKET  */
  YYSYMBOL_RE_LEFT_SQUARE_BRACKET = 27,    /* RE_LEFT_SQUARE_BRACKET  */
  YYSYMBOL_ALPHABET_DECLARATION = 28,      /* ALPHABET_DECLARATION  */
  YYSYMBOL_DIACRITICS_DECLARATION = 29,    /* DIACRITICS_DECLARATION  */
  YYSYMBOL_SETS_DECLARATION = 30,          /* SETS_DECLARATION  */
  YYSYMBOL_DEFINITION_DECLARATION = 31,    /* DEFINITION_DECLARATION  */
  YYSYMBOL_RULES_DECLARATION = 32,         /* RULES_DECLARATION  */
  YYSYMBOL_COLON = 33,                     /* COLON  */
  YYSYMBOL_SEMI_COLON = 34,                /* SEMI_COLON  */
  YYSYMBOL_EQUALS = 35,                    /* EQUALS  */
  YYSYMBOL_CENTER_MARKER = 36,             /* CENTER_MARKER  */
  YYSYMBOL_QUESTION_MARK = 37,             /* QUESTION_MARK  */
  YYSYMBOL_EXCEPT = 38,                    /* EXCEPT  */
  YYSYMBOL_RULE_NAME = 39,                 /* RULE_NAME  */
  YYSYMBOL_SYMBOL = 40,                    /* SYMBOL  */
  YYSYMBOL_DEFINITION_NAME = 41,           /* DEFINITION_NAME  */
  YYSYMBOL_NUMBER = 42,                    /* NUMBER  */
  YYSYMBOL_NUMBER_RANGE = 43,              /* NUMBER_RANGE  */
  YYSYMBOL_YYACCEPT = 44,                  /* $accept  */
  YYSYMBOL_ALL = 45,                       /* ALL  */
  YYSYMBOL_GRAMMAR = 46,                   /* GRAMMAR  */
  YYSYMBOL_GRAMMAR1 = 47,                  /* GRAMMAR1  */
  YYSYMBOL_GRAMMAR2 = 48,                  /* GRAMMAR2  */
  YYSYMBOL_GRAMMAR3 = 49,                  /* GRAMMAR3  */
  YYSYMBOL_GRAMMAR4 = 50,                  /* GRAMMAR4  */
  YYSYMBOL_RULES = 51,                     /* RULES  */
  YYSYMBOL_RULES_HEADER = 52,              /* RULES_HEADER  */
  YYSYMBOL_RULE_LIST = 53,                 /* RULE_LIST  */
  YYSYMBOL_RULE = 54,                      /* RULE  */
  YYSYMBOL_RULE_CENTER = 55,               /* RULE_CENTER  */
  YYSYMBOL_RE_RULE_CENTER = 56,            /* RE_RULE_CENTER  */
  YYSYMBOL_CENTER_LIST = 57,               /* CENTER_LIST  */
  YYSYMBOL_CENTER_PAIR = 58,               /* CENTER_PAIR  */
  YYSYMBOL_CENTER_SYMBOL = 59,             /* CENTER_SYMBOL  */
  YYSYMBOL_RULE_OPERATOR = 60,             /* RULE_OPERATOR  */
  YYSYMBOL_RE_RULE_OPERATOR = 61,          /* RE_RULE_OPERATOR  */
  YYSYMBOL_RULE_CONTEXTS = 62,             /* RULE_CONTEXTS  */
  YYSYMBOL_NEGATIVE_RULE_CONTEXTS = 63,    /* NEGATIVE_RULE_CONTEXTS  */
  YYSYMBOL_RULE_CONTEXT = 64,              /* RULE_CONTEXT  */
  YYSYMBOL_ALPHABET = 65,                  /* ALPHABET  */
  YYSYMBOL_ALPHABET_HEADER = 66,           /* ALPHABET_HEADER  */
  YYSYMBOL_DIACRITICS = 67,                /* DIACRITICS  */
  YYSYMBOL_DIACRITICS_HEADER = 68,         /* DIACRITICS_HEADER  */
  YYSYMBOL_SETS = 69,                      /* SETS  */
  YYSYMBOL_SETS_HEADER = 70,               /* SETS_HEADER  */
  YYSYMBOL_DEFINITIONS = 71,               /* DEFINITIONS  */
  YYSYMBOL_DEFINITION_HEADER = 72,         /* DEFINITION_HEADER  */
  YYSYMBOL_DEFINITION_LIST = 73,           /* DEFINITION_LIST  */
  YYSYMBOL_DEFINITION = 74,                /* DEFINITION  */
  YYSYMBOL_REGULAR_EXPRESSION = 75,        /* REGULAR_EXPRESSION  */
  YYSYMBOL_RE_LIST = 76,                   /* RE_LIST  */
  YYSYMBOL_RE = 77,                        /* RE  */
  YYSYMBOL_SET_LIST = 78,                  /* SET_LIST  */
  YYSYMBOL_SYMBOL_LIST = 79,               /* SYMBOL_LIST  */
  YYSYMBOL_SET_DEFINITION = 80,            /* SET_DEFINITION  */
  YYSYMBOL_ALPHABET_PAIR_LIST = 81,        /* ALPHABET_PAIR_LIST  */
  YYSYMBOL_PAIR = 82,                      /* PAIR  */
  YYSYMBOL_PAIR_SYMBOL = 83,               /* PAIR_SYMBOL  */
  YYSYMBOL_ALPHABET_PAIR = 84,             /* ALPHABET_PAIR  */
  YYSYMBOL_SEMI_COLON_LIST = 85            /* SEMI_COLON_LIST  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  22
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   124

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  44
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  42
/* YYNRULES -- Number of rules.  */
#define YYNRULES  82
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  131

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   298


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   198,   198,   201,   202,   204,   205,   207,   208,   210,
     211,   213,   215,   217,   220,   221,   223,   240,   253,   255,
     261,   264,   267,   269,   276,   282,   284,   287,   289,   291,
     293,   296,   298,   300,   302,   306,   307,   314,   315,   318,
     326,   329,   332,   339,   342,   344,   347,   349,   352,   353,
     355,   362,   364,   369,   374,   381,   382,   388,   390,   395,
     401,   403,   405,   407,   409,   411,   413,   415,   417,   433,
     434,   437,   438,   445,   452,   453,   455,   517,   524,   526,
     529,   536,   537
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "FREELY_INSERT",
  "DIFFERENCE", "INTERSECTION", "UNION", "STAR", "PLUS", "CONTAINMENT",
  "CONTAINMENT_ONCE", "TERM_COMPLEMENT", "COMPLEMENT", "POWER",
  "RIGHT_SQUARE_BRACKET", "RIGHT_PARENTHESIS", "LEFT_SQUARE_BRACKET",
  "LEFT_PARENTHESIS", "LEFT_RESTRICTION_ARROW", "LEFT_ARROW",
  "RIGHT_ARROW", "LEFT_RIGHT_ARROW", "RE_LEFT_RESTRICTION_ARROW",
  "RE_LEFT_ARROW", "RE_RIGHT_ARROW", "RE_LEFT_RIGHT_ARROW",
  "RE_RIGHT_SQUARE_BRACKET", "RE_LEFT_SQUARE_BRACKET",
  "ALPHABET_DECLARATION", "DIACRITICS_DECLARATION", "SETS_DECLARATION",
  "DEFINITION_DECLARATION", "RULES_DECLARATION", "COLON", "SEMI_COLON",
  "EQUALS", "CENTER_MARKER", "QUESTION_MARK", "EXCEPT", "RULE_NAME",
  "SYMBOL", "DEFINITION_NAME", "NUMBER", "NUMBER_RANGE", "$accept", "ALL",
  "GRAMMAR", "GRAMMAR1", "GRAMMAR2", "GRAMMAR3", "GRAMMAR4", "RULES",
  "RULES_HEADER", "RULE_LIST", "RULE", "RULE_CENTER", "RE_RULE_CENTER",
  "CENTER_LIST", "CENTER_PAIR", "CENTER_SYMBOL", "RULE_OPERATOR",
  "RE_RULE_OPERATOR", "RULE_CONTEXTS", "NEGATIVE_RULE_CONTEXTS",
  "RULE_CONTEXT", "ALPHABET", "ALPHABET_HEADER", "DIACRITICS",
  "DIACRITICS_HEADER", "SETS", "SETS_HEADER", "DEFINITIONS",
  "DEFINITION_HEADER", "DEFINITION_LIST", "DEFINITION",
  "REGULAR_EXPRESSION", "RE_LIST", "RE", "SET_LIST", "SYMBOL_LIST",
  "SET_DEFINITION", "ALPHABET_PAIR_LIST", "PAIR", "PAIR_SYMBOL",
  "ALPHABET_PAIR", "SEMI_COLON_LIST", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-68)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-39)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int8 yypact[] =
{
      59,   -68,   -68,   -68,   -68,   -68,     2,   -68,   -68,   -68,
     -68,   -68,   -68,   -68,    63,   -68,    73,   -68,    78,   -68,
     -28,   -68,   -68,   -23,   -68,     0,   -68,    25,   -68,    -3,
     -68,   -29,    34,   -68,   -68,    48,   -68,    26,   -68,    26,
      65,   -68,    66,   -68,    38,   -68,   -68,   -68,    49,    74,
     -68,    79,    71,   -68,   -68,   -68,     7,   -68,    27,    -2,
      38,   -68,   -68,   -68,   -68,   -68,   -68,   -68,   -68,   -68,
     -68,    38,   -68,    25,    18,    38,   -68,   -68,   -68,   -68,
     -68,    -2,    -2,    -2,    -2,   -68,   -68,   -68,   -68,    80,
      69,   -68,    81,   -68,     5,     5,   -68,    26,    26,   -68,
      -2,    -2,    -2,   102,   102,   102,   102,    52,    58,    75,
      -2,   -68,   -68,   -13,    46,   -68,   -68,   -68,    13,   -68,
     -68,   -68,   -68,    72,   -68,   -68,   -68,     6,   -68,    18,
      26
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       0,    41,    43,    45,    47,    13,     0,     2,     4,     6,
       8,    10,    11,    14,     0,    74,     0,    71,     0,    69,
       0,    48,     1,    12,     3,     0,     5,     0,     7,    44,
       9,    46,     0,    15,    81,     0,    75,    40,    72,    42,
       0,    70,     0,    49,     0,    55,    26,    25,     0,     0,
      18,     0,     0,    82,    71,    55,     0,    22,     0,    51,
       0,    29,    27,    28,    30,    35,    33,    31,    32,    34,
      35,     0,    80,     0,     0,     0,    20,    55,    55,    55,
      21,     0,     0,     0,     0,    55,    55,    79,    78,     0,
      56,    57,     0,    19,    55,    55,    24,    73,    50,    23,
      54,    53,    52,    62,    63,    65,    64,     0,     0,     0,
       0,    60,    61,     0,     0,    35,    16,    36,     0,    17,
      66,    67,    77,    68,    58,    59,    76,    55,    55,     0,
      39
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -68,   -68,   -68,   103,   104,   100,    99,   -68,   -68,   -68,
     -68,   -68,   -68,   -68,   -24,    50,   -68,   -68,   -67,    28,
     -68,   -68,   -68,   -68,   -68,   -68,   -68,   -68,   -68,   -68,
     -68,   -44,    29,   -56,   -68,    68,   -68,   -68,   -68,    10,
     -68,   -27
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
       0,     6,     7,     8,     9,    10,    11,    12,    13,    23,
      33,    48,    49,    56,    50,    51,    65,    70,    94,   116,
     117,    14,    15,    16,    17,    18,    19,    20,    21,    31,
      43,   118,    59,    90,    29,    27,    41,    25,    91,    92,
      36,    37
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      39,    58,    22,    95,     5,   -37,   -38,    81,    82,    83,
      84,    74,    42,    75,    85,    86,    32,    77,    78,    79,
      57,    76,    77,    78,    79,   103,   104,   105,   106,   124,
     125,    77,    78,    79,    34,    87,    93,    40,    88,    89,
      35,   107,   108,   115,   -37,   -38,    97,    98,   127,   128,
      44,    99,    34,    80,   123,    60,    77,    78,    79,    34,
      53,    45,    77,    78,    79,    38,   120,    61,    62,    63,
      64,    46,   110,   121,    47,    46,   111,   112,    47,   111,
     112,    52,   113,    87,   129,   113,    88,     1,     2,     3,
       4,     5,     2,     3,     4,     5,    66,    67,    68,    69,
      54,    55,   130,     3,     4,     5,   100,   101,   102,     4,
       5,    72,    71,   109,   114,   113,   122,    24,    28,    30,
      26,    96,    73,   119,   126
};

static const yytype_uint8 yycheck[] =
{
      27,    45,     0,    70,    32,     0,     0,     9,    10,    11,
      12,    55,    41,     6,    16,    17,    39,     4,     5,     6,
      44,    14,     4,     5,     6,    81,    82,    83,    84,    42,
      43,     4,     5,     6,    34,    37,    60,    40,    40,    41,
      40,    85,    86,    38,    39,    39,    73,    74,   115,    36,
      16,    75,    34,    26,   110,     6,     4,     5,     6,    34,
      34,    27,     4,     5,     6,    40,    14,    18,    19,    20,
      21,    37,     3,    15,    40,    37,     7,     8,    40,     7,
       8,    33,    13,    37,   128,    13,    40,    28,    29,    30,
      31,    32,    29,    30,    31,    32,    22,    23,    24,    25,
      35,    35,   129,    30,    31,    32,    77,    78,    79,    31,
      32,    40,    33,    33,    33,    13,    41,    14,    18,    20,
      16,    71,    54,    95,   114
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    28,    29,    30,    31,    32,    45,    46,    47,    48,
      49,    50,    51,    52,    65,    66,    67,    68,    69,    70,
      71,    72,     0,    53,    47,    81,    48,    79,    49,    78,
      50,    73,    39,    54,    34,    40,    84,    85,    40,    85,
      40,    80,    41,    74,    16,    27,    37,    40,    55,    56,
      58,    59,    33,    34,    35,    35,    57,    58,    75,    76,
       6,    18,    19,    20,    21,    60,    22,    23,    24,    25,
      61,    33,    40,    79,    75,     6,    14,     4,     5,     6,
      26,     9,    10,    11,    12,    16,    17,    37,    40,    41,
      77,    82,    83,    58,    62,    62,    59,    85,    85,    58,
      76,    76,    76,    77,    77,    77,    77,    75,    75,    33,
       3,     7,     8,    13,    33,    38,    63,    64,    75,    63,
      14,    15,    41,    77,    42,    43,    83,    62,    36,    75,
      85
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    44,    45,    46,    46,    47,    47,    48,    48,    49,
      49,    50,    51,    52,    53,    53,    54,    54,    55,    55,
      55,    56,    57,    57,    58,    59,    59,    60,    60,    60,
      60,    61,    61,    61,    61,    62,    62,    63,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    73,
      74,    75,    75,    75,    75,    76,    76,    77,    77,    77,
      77,    77,    77,    77,    77,    77,    77,    77,    77,    78,
      78,    79,    79,    80,    81,    81,    82,    82,    83,    83,
      84,    85,    85
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     1,     2,     1,     2,
       1,     1,     2,     1,     0,     2,     5,     5,     1,     3,
       3,     3,     1,     3,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     2,     0,     2,     4,
       3,     1,     3,     1,     2,     1,     2,     1,     0,     2,
       4,     1,     3,     3,     3,     0,     2,     1,     3,     3,
       2,     2,     2,     2,     2,     2,     3,     3,     3,     0,
       2,     0,     2,     4,     0,     2,     3,     3,     1,     1,
       3,     1,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* ALL: GRAMMAR  */
#line 198 "htwolcpre3-parser.yy"
             {}
#line 1519 "htwolcpre3-parser.cc"
    break;

  case 13: /* RULES_HEADER: RULES_DECLARATION  */
#line 218 "htwolcpre3-parser.yy"
{ htwolcpre3message("Reading rules and compiling their contexts and centers."); }
#line 1525 "htwolcpre3-parser.cc"
    break;

  case 16: /* RULE: RULE_NAME RULE_CENTER RULE_OPERATOR RULE_CONTEXTS NEGATIVE_RULE_CONTEXTS  */
#line 224 "htwolcpre3-parser.yy"
{
  // Subtract negative contexts from positive contexts.
  (yyvsp[-1].regular_expression)->apply(&HfstTransducer::subtract,*(yyvsp[0].regular_expression));

  if (verbose_)
    { htwolcpre3message(std::string("Processing: ")+ get_name((yyvsp[-4].value))); }

  if ((yyvsp[-3].symbol_pair_range)->size() == 1)
    { grammar->add_rule((yyvsp[-4].value),(*(yyvsp[-3].symbol_pair_range))[0],(yyvsp[-2].rule_operator),OtherSymbolTransducerVector(1,*(yyvsp[-1].regular_expression))); }
  else
    { grammar->add_rule((yyvsp[-4].value),*(yyvsp[-3].symbol_pair_range),(yyvsp[-2].rule_operator),OtherSymbolTransducerVector(1,*(yyvsp[-1].regular_expression))); }
  free((yyvsp[-4].value));
  delete (yyvsp[-3].symbol_pair_range);
  delete (yyvsp[-1].regular_expression);
  delete (yyvsp[0].regular_expression);
}
#line 1546 "htwolcpre3-parser.cc"
    break;

  case 17: /* RULE: RULE_NAME RE_RULE_CENTER RE_RULE_OPERATOR RULE_CONTEXTS NEGATIVE_RULE_CONTEXTS  */
#line 242 "htwolcpre3-parser.yy"
{
  // Subtract negative contexts from positive contexts.
  (yyvsp[-1].regular_expression)->apply(&HfstTransducer::subtract,*(yyvsp[0].regular_expression));

  grammar->add_rule((yyvsp[-4].value),*(yyvsp[-3].regular_expression),(yyvsp[-2].rule_operator),OtherSymbolTransducerVector(1,*(yyvsp[-1].regular_expression)));
  free((yyvsp[-4].value));
  delete (yyvsp[-3].regular_expression);
  delete (yyvsp[-1].regular_expression);
  delete (yyvsp[0].regular_expression);
}
#line 1561 "htwolcpre3-parser.cc"
    break;

  case 18: /* RULE_CENTER: CENTER_PAIR  */
#line 254 "htwolcpre3-parser.yy"
{ (yyval.symbol_pair_range) = (yyvsp[0].symbol_pair_range); }
#line 1567 "htwolcpre3-parser.cc"
    break;

  case 19: /* RULE_CENTER: RULE_CENTER UNION CENTER_PAIR  */
#line 256 "htwolcpre3-parser.yy"
{
  (yyval.symbol_pair_range) = (yyvsp[-2].symbol_pair_range);
  (yyval.symbol_pair_range)->push_back(*(yyvsp[0].symbol_pair_range)->begin());
  delete (yyvsp[0].symbol_pair_range);
}
#line 1577 "htwolcpre3-parser.cc"
    break;

  case 20: /* RULE_CENTER: LEFT_SQUARE_BRACKET CENTER_LIST RIGHT_SQUARE_BRACKET  */
#line 262 "htwolcpre3-parser.yy"
{ (yyval.symbol_pair_range) = (yyvsp[-1].symbol_pair_range); }
#line 1583 "htwolcpre3-parser.cc"
    break;

  case 21: /* RE_RULE_CENTER: RE_LEFT_SQUARE_BRACKET REGULAR_EXPRESSION RE_RIGHT_SQUARE_BRACKET  */
#line 265 "htwolcpre3-parser.yy"
{ (yyval.regular_expression) = (yyvsp[-1].regular_expression); }
#line 1589 "htwolcpre3-parser.cc"
    break;

  case 22: /* CENTER_LIST: CENTER_PAIR  */
#line 268 "htwolcpre3-parser.yy"
{ (yyval.symbol_pair_range) = (yyvsp[0].symbol_pair_range); }
#line 1595 "htwolcpre3-parser.cc"
    break;

  case 23: /* CENTER_LIST: CENTER_LIST UNION CENTER_PAIR  */
#line 270 "htwolcpre3-parser.yy"
{
  (yyval.symbol_pair_range) = (yyvsp[-2].symbol_pair_range);
  (yyval.symbol_pair_range)->push_back(*(yyvsp[0].symbol_pair_range)->begin());
  delete (yyvsp[0].symbol_pair_range);
}
#line 1605 "htwolcpre3-parser.cc"
    break;

  case 24: /* CENTER_PAIR: CENTER_SYMBOL COLON CENTER_SYMBOL  */
#line 277 "htwolcpre3-parser.yy"
{
  (yyval.symbol_pair_range) = alphabet.get_symbol_pair_vector(SymbolPair((yyvsp[-2].value),(yyvsp[0].value)));
  free((yyvsp[-2].value)); free((yyvsp[0].value));
}
#line 1614 "htwolcpre3-parser.cc"
    break;

  case 25: /* CENTER_SYMBOL: SYMBOL  */
#line 283 "htwolcpre3-parser.yy"
{ (yyval.value) = (yyvsp[0].value); }
#line 1620 "htwolcpre3-parser.cc"
    break;

  case 26: /* CENTER_SYMBOL: QUESTION_MARK  */
#line 285 "htwolcpre3-parser.yy"
{ (yyval.value) = string_copy("__HFST_TWOLC_?"); }
#line 1626 "htwolcpre3-parser.cc"
    break;

  case 27: /* RULE_OPERATOR: LEFT_ARROW  */
#line 288 "htwolcpre3-parser.yy"
{ (yyval.rule_operator) = op::LEFT; }
#line 1632 "htwolcpre3-parser.cc"
    break;

  case 28: /* RULE_OPERATOR: RIGHT_ARROW  */
#line 290 "htwolcpre3-parser.yy"
{ (yyval.rule_operator) = op::RIGHT; }
#line 1638 "htwolcpre3-parser.cc"
    break;

  case 29: /* RULE_OPERATOR: LEFT_RESTRICTION_ARROW  */
#line 292 "htwolcpre3-parser.yy"
{ (yyval.rule_operator) = op::NOT_LEFT; }
#line 1644 "htwolcpre3-parser.cc"
    break;

  case 30: /* RULE_OPERATOR: LEFT_RIGHT_ARROW  */
#line 294 "htwolcpre3-parser.yy"
{ (yyval.rule_operator) = op::LEFT_RIGHT; }
#line 1650 "htwolcpre3-parser.cc"
    break;

  case 31: /* RE_RULE_OPERATOR: RE_LEFT_ARROW  */
#line 297 "htwolcpre3-parser.yy"
{ (yyval.rule_operator) = op::RE_LEFT; }
#line 1656 "htwolcpre3-parser.cc"
    break;

  case 32: /* RE_RULE_OPERATOR: RE_RIGHT_ARROW  */
#line 299 "htwolcpre3-parser.yy"
{ (yyval.rule_operator) = op::RE_RIGHT; }
#line 1662 "htwolcpre3-parser.cc"
    break;

  case 33: /* RE_RULE_OPERATOR: RE_LEFT_RESTRICTION_ARROW  */
#line 301 "htwolcpre3-parser.yy"
{ (yyval.rule_operator) = op::RE_NOT_LEFT; }
#line 1668 "htwolcpre3-parser.cc"
    break;

  case 34: /* RE_RULE_OPERATOR: RE_LEFT_RIGHT_ARROW  */
#line 303 "htwolcpre3-parser.yy"
{ (yyval.rule_operator) = op::RE_LEFT_RIGHT; }
#line 1674 "htwolcpre3-parser.cc"
    break;

  case 35: /* RULE_CONTEXTS: %empty  */
#line 306 "htwolcpre3-parser.yy"
{ (yyval.regular_expression) = new OtherSymbolTransducer(); }
#line 1680 "htwolcpre3-parser.cc"
    break;

  case 36: /* RULE_CONTEXTS: RULE_CONTEXTS RULE_CONTEXT  */
#line 308 "htwolcpre3-parser.yy"
{
  (yyval.regular_expression) = &(yyvsp[-1].regular_expression)->apply(&HfstTransducer::disjunct,*(yyvsp[0].regular_expression));
  delete (yyvsp[0].regular_expression);
}
#line 1689 "htwolcpre3-parser.cc"
    break;

  case 37: /* NEGATIVE_RULE_CONTEXTS: %empty  */
#line 314 "htwolcpre3-parser.yy"
{ (yyval.regular_expression) = new OtherSymbolTransducer(); }
#line 1695 "htwolcpre3-parser.cc"
    break;

  case 38: /* NEGATIVE_RULE_CONTEXTS: EXCEPT RULE_CONTEXTS  */
#line 316 "htwolcpre3-parser.yy"
{ (yyval.regular_expression) = (yyvsp[0].regular_expression); }
#line 1701 "htwolcpre3-parser.cc"
    break;

  case 39: /* RULE_CONTEXT: REGULAR_EXPRESSION CENTER_MARKER REGULAR_EXPRESSION SEMI_COLON_LIST  */
#line 320 "htwolcpre3-parser.yy"
{
  (yyval.regular_expression) = new OtherSymbolTransducer(OtherSymbolTransducer::get_context(*(yyvsp[-3].regular_expression),*(yyvsp[-1].regular_expression)));
  delete (yyvsp[-3].regular_expression);
  delete (yyvsp[-1].regular_expression);
}
#line 1711 "htwolcpre3-parser.cc"
    break;

  case 40: /* ALPHABET: ALPHABET_HEADER ALPHABET_PAIR_LIST SEMI_COLON_LIST  */
#line 327 "htwolcpre3-parser.yy"
{ alphabet.alphabet_done(); }
#line 1717 "htwolcpre3-parser.cc"
    break;

  case 41: /* ALPHABET_HEADER: ALPHABET_DECLARATION  */
#line 330 "htwolcpre3-parser.yy"
{ htwolcpre3message("Reading alphabet."); }
#line 1723 "htwolcpre3-parser.cc"
    break;

  case 42: /* DIACRITICS: DIACRITICS_HEADER SYMBOL_LIST SEMI_COLON_LIST  */
#line 333 "htwolcpre3-parser.yy"
{
  grammar->define_diacritics(*(yyvsp[-1].symbol_range));
  alphabet.define_diacritics(*(yyvsp[-1].symbol_range));
  delete (yyvsp[-1].symbol_range);
}
#line 1733 "htwolcpre3-parser.cc"
    break;

  case 43: /* DIACRITICS_HEADER: DIACRITICS_DECLARATION  */
#line 340 "htwolcpre3-parser.yy"
{ htwolcpre3message("Reading diacritics."); }
#line 1739 "htwolcpre3-parser.cc"
    break;

  case 45: /* SETS_HEADER: SETS_DECLARATION  */
#line 345 "htwolcpre3-parser.yy"
{ htwolcpre3message("Reading sets."); }
#line 1745 "htwolcpre3-parser.cc"
    break;

  case 47: /* DEFINITION_HEADER: DEFINITION_DECLARATION  */
#line 350 "htwolcpre3-parser.yy"
{ htwolcpre3message("Reading and compiling definitions."); }
#line 1751 "htwolcpre3-parser.cc"
    break;

  case 50: /* DEFINITION: DEFINITION_NAME EQUALS REGULAR_EXPRESSION SEMI_COLON_LIST  */
#line 356 "htwolcpre3-parser.yy"
{
  definition_map[(yyvsp[-3].value)] = *(yyvsp[-1].regular_expression);
  free((yyvsp[-3].value));
  delete (yyvsp[-1].regular_expression);
}
#line 1761 "htwolcpre3-parser.cc"
    break;

  case 51: /* REGULAR_EXPRESSION: RE_LIST  */
#line 363 "htwolcpre3-parser.yy"
{ (yyval.regular_expression) = (yyvsp[0].regular_expression); }
#line 1767 "htwolcpre3-parser.cc"
    break;

  case 52: /* REGULAR_EXPRESSION: REGULAR_EXPRESSION UNION RE_LIST  */
#line 365 "htwolcpre3-parser.yy"
{
  (yyval.regular_expression) = &(yyvsp[-2].regular_expression)->apply(&HfstTransducer::disjunct,*(yyvsp[0].regular_expression));
  delete (yyvsp[0].regular_expression);
}
#line 1776 "htwolcpre3-parser.cc"
    break;

  case 53: /* REGULAR_EXPRESSION: REGULAR_EXPRESSION INTERSECTION RE_LIST  */
#line 370 "htwolcpre3-parser.yy"
{
  (yyval.regular_expression) = &(yyvsp[-2].regular_expression)->apply(&HfstTransducer::intersect,*(yyvsp[0].regular_expression));
  delete (yyvsp[0].regular_expression);
}
#line 1785 "htwolcpre3-parser.cc"
    break;

  case 54: /* REGULAR_EXPRESSION: REGULAR_EXPRESSION DIFFERENCE RE_LIST  */
#line 375 "htwolcpre3-parser.yy"
{
  (yyval.regular_expression) = &(yyvsp[-2].regular_expression)->apply(&HfstTransducer::subtract,*(yyvsp[0].regular_expression));
  delete (yyvsp[0].regular_expression);
}
#line 1794 "htwolcpre3-parser.cc"
    break;

  case 55: /* RE_LIST: %empty  */
#line 381 "htwolcpre3-parser.yy"
{ (yyval.regular_expression) = new OtherSymbolTransducer(HFST_EPSILON); }
#line 1800 "htwolcpre3-parser.cc"
    break;

  case 56: /* RE_LIST: RE_LIST RE  */
#line 383 "htwolcpre3-parser.yy"
{
  (yyval.regular_expression) = &(yyvsp[-1].regular_expression)->apply(&HfstTransducer::concatenate,*(yyvsp[0].regular_expression));
  delete (yyvsp[0].regular_expression);
}
#line 1809 "htwolcpre3-parser.cc"
    break;

  case 57: /* RE: PAIR  */
#line 389 "htwolcpre3-parser.yy"
{ (yyval.regular_expression) = (yyvsp[0].regular_expression); }
#line 1815 "htwolcpre3-parser.cc"
    break;

  case 58: /* RE: RE POWER NUMBER  */
#line 391 "htwolcpre3-parser.yy"
{
  (yyval.regular_expression) = &(yyvsp[-2].regular_expression)->apply(&HfstTransducer::repeat_n,get_number((yyvsp[0].value)));
  free((yyvsp[0].value));
}
#line 1824 "htwolcpre3-parser.cc"
    break;

  case 59: /* RE: RE POWER NUMBER_RANGE  */
#line 396 "htwolcpre3-parser.yy"
{
  (yyval.regular_expression) = &(yyvsp[-2].regular_expression)->apply(&HfstTransducer::repeat_n_to_k,
          get_number((yyvsp[0].value)),get_second_number((yyvsp[0].value)));
  free((yyvsp[0].value));
}
#line 1834 "htwolcpre3-parser.cc"
    break;

  case 60: /* RE: RE STAR  */
#line 402 "htwolcpre3-parser.yy"
{ (yyval.regular_expression) = &(yyvsp[-1].regular_expression)->apply(&HfstTransducer::repeat_star); }
#line 1840 "htwolcpre3-parser.cc"
    break;

  case 61: /* RE: RE PLUS  */
#line 404 "htwolcpre3-parser.yy"
{ (yyval.regular_expression) = &(yyvsp[-1].regular_expression)->apply(&HfstTransducer::repeat_plus); }
#line 1846 "htwolcpre3-parser.cc"
    break;

  case 62: /* RE: CONTAINMENT RE  */
#line 406 "htwolcpre3-parser.yy"
{ (yyval.regular_expression) = &(yyvsp[0].regular_expression)->contained(); }
#line 1852 "htwolcpre3-parser.cc"
    break;

  case 63: /* RE: CONTAINMENT_ONCE RE  */
#line 408 "htwolcpre3-parser.yy"
{ (yyval.regular_expression) = &(yyvsp[0].regular_expression)->contained_once(); }
#line 1858 "htwolcpre3-parser.cc"
    break;

  case 64: /* RE: COMPLEMENT RE  */
#line 410 "htwolcpre3-parser.yy"
{ (yyval.regular_expression) = &(yyvsp[0].regular_expression)->negated(); }
#line 1864 "htwolcpre3-parser.cc"
    break;

  case 65: /* RE: TERM_COMPLEMENT RE  */
#line 412 "htwolcpre3-parser.yy"
{ (yyval.regular_expression) = &(yyvsp[0].regular_expression)->term_complemented(); }
#line 1870 "htwolcpre3-parser.cc"
    break;

  case 66: /* RE: LEFT_SQUARE_BRACKET REGULAR_EXPRESSION RIGHT_SQUARE_BRACKET  */
#line 414 "htwolcpre3-parser.yy"
{ (yyval.regular_expression) = (yyvsp[-1].regular_expression); }
#line 1876 "htwolcpre3-parser.cc"
    break;

  case 67: /* RE: LEFT_PARENTHESIS REGULAR_EXPRESSION RIGHT_PARENTHESIS  */
#line 416 "htwolcpre3-parser.yy"
{ (yyval.regular_expression) = &(yyvsp[-1].regular_expression)->apply(&HfstTransducer::optionalize); }
#line 1882 "htwolcpre3-parser.cc"
    break;

  case 68: /* RE: RE FREELY_INSERT RE  */
#line 418 "htwolcpre3-parser.yy"
{
  (yyvsp[-2].regular_expression)->apply
    (&HfstTransducer::insert_freely,
     SymbolPair(TWOLC_FREELY_INSERT,TWOLC_FREELY_INSERT),
     true);
  (yyvsp[-2].regular_expression)->apply
    (&HfstTransducer::substitute,
     SymbolPair(TWOLC_FREELY_INSERT,TWOLC_FREELY_INSERT),
     *(yyvsp[0].regular_expression),
     true);
  (yyval.regular_expression) = (yyvsp[-2].regular_expression);

  delete (yyvsp[0].regular_expression);
}
#line 1901 "htwolcpre3-parser.cc"
    break;

  case 71: /* SYMBOL_LIST: %empty  */
#line 437 "htwolcpre3-parser.yy"
{ (yyval.symbol_range) = new SymbolRange; }
#line 1907 "htwolcpre3-parser.cc"
    break;

  case 72: /* SYMBOL_LIST: SYMBOL_LIST SYMBOL  */
#line 439 "htwolcpre3-parser.yy"
{
  (yyvsp[-1].symbol_range)->push_back((yyvsp[0].value));
  (yyval.symbol_range) = (yyvsp[-1].symbol_range);
  free((yyvsp[0].value));
}
#line 1917 "htwolcpre3-parser.cc"
    break;

  case 73: /* SET_DEFINITION: SYMBOL EQUALS SYMBOL_LIST SEMI_COLON_LIST  */
#line 446 "htwolcpre3-parser.yy"
{
  alphabet.define_set((yyvsp[-3].value),*(yyvsp[-1].symbol_range));
  free((yyvsp[-3].value));
  delete (yyvsp[-1].symbol_range);
}
#line 1927 "htwolcpre3-parser.cc"
    break;

  case 76: /* PAIR: PAIR_SYMBOL COLON PAIR_SYMBOL  */
#line 456 "htwolcpre3-parser.yy"
{
  if (std::string("__HFST_TWOLC_0") == (yyvsp[-2].value) &&
      std::string("__HFST_TWOLC_0") == (yyvsp[0].value))
    { (yyval.regular_expression) = new OtherSymbolTransducer(HFST_EPSILON); }
  else if (std::string("__HFST_TWOLC_#") == (yyvsp[-2].value))
    {
      // __HFST_TWOLC_# corresponds to the #-symbol in grammars. It should
      // be split into an absolute word boundary "__HFST_TWOLC_.#." and a
      // relative word boundary "#". On the surface the relative word-boundary
      // may correspond to whatever it did correspond to in the rule file.
      // The absolute word boundary surface realization is treated the same as
      // the surface realizations of other absolute word boundaries.
      OtherSymbolTransducer wb =
    alphabet.get_transducer(SymbolPair
                ("__HFST_TWOLC_.#.","__HFST_TWOLC_.#."));
      OtherSymbolTransducer alt_wb =
    alphabet.get_transducer
    (SymbolPair
     ("#",(yyvsp[0].value) == std::string("__HFST_TWOLC_#") ? "#" : (yyvsp[0].value)));
      wb.apply(&HfstTransducer::disjunct,alt_wb);

      (yyval.regular_expression) = new OtherSymbolTransducer(wb);
    }
  else
    { (yyval.regular_expression) = new OtherSymbolTransducer
    (alphabet.get_transducer(SymbolPair((yyvsp[-2].value),(yyvsp[0].value))));
      if (alphabet.is_empty_pair(SymbolPair((yyvsp[-2].value),(yyvsp[0].value))))
    {
      std::string error;
      if (std::string((yyvsp[-2].value)) == std::string((yyvsp[0].value)))
        {
          std::string symbol = Rule::get_print_name((yyvsp[-2].value));

          error = std::string("The pair set ") + symbol + " is empty.";
        }
      else
        {
          std::string symbol1 = Rule::get_print_name((yyvsp[-2].value));
          std::string symbol2 = Rule::get_print_name((yyvsp[0].value));

          error = std::string("The pair set ") + symbol1 + ":" + symbol2 +
        " is empty.";
        }
      error +=  std::string("\n\n") +

        "Note that a pair set X:Y can be empty, even if the sets X and\n"+
            "Y are non-empty, since every symbol pair has to be declared in\n"+
        "the alphabet or it has to be the center of a rule, or be in\n"  +
        "the context of a rule or result from substituting values for\n" +
        "variables in a rule with variables.\n\n" +

        "Compilation is terminated because a rule context, definition\n" +
        "or rule center becomes empty.\n\n";

      htwolcpre3_semantic_error(error.c_str());
    }
    }

  free((yyvsp[-2].value));
  free((yyvsp[0].value));
}
#line 1993 "htwolcpre3-parser.cc"
    break;

  case 77: /* PAIR: DEFINITION_NAME COLON DEFINITION_NAME  */
#line 518 "htwolcpre3-parser.yy"
{
  (yyval.regular_expression) = new OtherSymbolTransducer(definition_map[(yyvsp[-2].value)]);
  free((yyvsp[-2].value));
  free((yyvsp[0].value));
}
#line 2003 "htwolcpre3-parser.cc"
    break;

  case 78: /* PAIR_SYMBOL: SYMBOL  */
#line 525 "htwolcpre3-parser.yy"
{ (yyval.value) = (yyvsp[0].value); }
#line 2009 "htwolcpre3-parser.cc"
    break;

  case 79: /* PAIR_SYMBOL: QUESTION_MARK  */
#line 527 "htwolcpre3-parser.yy"
{ (yyval.value) = string_copy("__HFST_TWOLC_?"); }
#line 2015 "htwolcpre3-parser.cc"
    break;

  case 80: /* ALPHABET_PAIR: SYMBOL COLON SYMBOL  */
#line 530 "htwolcpre3-parser.yy"
{
  alphabet.define_alphabet_pair(SymbolPair((yyvsp[-2].value),(yyvsp[0].value)));
  free((yyvsp[-2].value));
  free((yyvsp[0].value));
}
#line 2025 "htwolcpre3-parser.cc"
    break;


#line 2029 "htwolcpre3-parser.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 539 "htwolcpre3-parser.yy"


// Print warning.
void htwolcpre3warn(const char * warning)
{
#ifdef DEBUG_TWOLC_3_GRAMMAR
  std::cerr << warning << std::endl;
#else
  (void)warning;
#endif
  htwolcpre3_input_reader.warn(warning);
}

// Print error messge and throw an exception
void htwolcpre3error(const char * text)
{
  (void)text;
  htwolcpre3_input_reader.error(text);
  HFST_THROW(HfstException);
}

// Print error messge and exit 1.
void htwolcpre3_semantic_error(const char * text)
{
  htwolcpre3_input_reader.error(text);
  std::cerr << std::endl << "Error: " << text << std::endl;
  HFST_THROW(HfstException);
}

unsigned int get_number(const std::string &s)
{
  // skip yhe prefix "HFST_TWOLC_NUMBER=".
  std::istringstream i(s.substr(20));
  unsigned int number;
  i >> number;
  return number;
}

unsigned int get_second_number(const std::string &s)
{
  // skip yhe prefix "HFST_TWOLC_NUMBER=".
  std::istringstream i(s.substr(s.find(',')+1));
  unsigned int number;
  i >> number;
  return number;
}

void htwolcpre3message(const std::string &m)
{
  if (! silent_)
    { std::cerr << m << std::endl; }
}

std::string get_name(const std::string &s)
{
  std::string ss = s;
  size_t pos = 0;
  while ((pos = ss.find("__HFST_TWOLC_RULE_NAME=")) != std::string::npos)
    { ss.replace(pos,std::string("__HFST_TWOLC_RULE_NAME=").size(),""); }
  while ((pos = ss.find("__HFST_TWOLC_SPACE")) != std::string::npos)
    { ss.replace(pos,std::string("__HFST_TWOLC_SPACE").size()," "); }
  return ss;
}

