/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         hxfstparse
#define yylex           hxfstlex
#define yyerror         hxfsterror
#define yydebug         hxfstdebug
#define yynerrs         hxfstnerrs
#define yylval          hxfstlval
#define yychar          hxfstchar
#define yylloc          hxfstlloc

/* First part of user prologue.  */
#line 1 "xfst-parser.yy"

// Copyright (c) 2016 University of Helsinki
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 3 of the License, or (at your option) any later version.
// See the file COPYING included with this distribution for more
// information.

//! @file xfst-parser.yy
//!
//! @brief A parser for xfst
//!
//! @author Tommi A. Pirinen

#if HAVE_CONFIG_H
#  include <config.h>
#endif

#include <cstdlib>
#include <cstdio>

#include <string>
using std::string;

namespace hfst {
  class HfstTransducer;
}

#include "XfstCompiler.h"
#include "xfst-utils.h"

#define CHECK if (hfst::xfst::xfst_->get_fail_flag()) { YYABORT; }

// obligatory yacc stuff
extern int hxfstlineno;
void hxfsterror(const char *text);
int hxfstlex(void);


#line 121 "xfst-parser.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_HXFST_XFST_PARSER_HH_INCLUDED
# define YY_HXFST_XFST_PARSER_HH_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int hxfstdebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    APROPOS = 258,                 /* APROPOS  */
    DESCRIBE = 259,                /* DESCRIBE  */
    ECHO_ = 260,                   /* ECHO_  */
    SYSTEM = 261,                  /* SYSTEM  */
    QUIT = 262,                    /* QUIT  */
    HFST = 263,                    /* HFST  */
    NAMETOKEN = 264,               /* NAMETOKEN  */
    NAMECHAR = 265,                /* NAMECHAR  */
    GLOB = 266,                    /* GLOB  */
    PROTOTYPE = 267,               /* PROTOTYPE  */
    DEFINE_NAME = 268,             /* DEFINE_NAME  */
    DEFINE_FUNCTION = 269,         /* DEFINE_FUNCTION  */
    RANGE = 270,                   /* RANGE  */
    REDIRECT_IN = 271,             /* REDIRECT_IN  */
    REDIRECT_OUT = 272,            /* REDIRECT_OUT  */
    SAVE_PROLOG = 273,             /* SAVE_PROLOG  */
    FOR = 274,                     /* FOR  */
    REVERSE = 275,                 /* REVERSE  */
    VIEW = 276,                    /* VIEW  */
    LOADD = 277,                   /* LOADD  */
    PRINT_LABEL_COUNT = 278,       /* PRINT_LABEL_COUNT  */
    TEST_OVERLAP = 279,            /* TEST_OVERLAP  */
    TEST_NONNULL = 280,            /* TEST_NONNULL  */
    CONCATENATE = 281,             /* CONCATENATE  */
    LOADS = 282,                   /* LOADS  */
    INVERT = 283,                  /* INVERT  */
    PRINT_ALIASES = 284,           /* PRINT_ALIASES  */
    PRINT_LABELS = 285,            /* PRINT_LABELS  */
    XFST_OPTIONAL = 286,           /* XFST_OPTIONAL  */
    PRINT_SHORTEST_STRING_SIZE = 287, /* PRINT_SHORTEST_STRING_SIZE  */
    READ_PROPS = 288,              /* READ_PROPS  */
    TEST_FUNCT = 289,              /* TEST_FUNCT  */
    PRINT_LABELMAPS = 290,         /* PRINT_LABELMAPS  */
    SUBSTRING = 291,               /* SUBSTRING  */
    COMPOSE = 292,                 /* COMPOSE  */
    READ_SPACED = 293,             /* READ_SPACED  */
    TEST_UPPER_UNI = 294,          /* TEST_UPPER_UNI  */
    COLLECT_EPSILON_LOOPS = 295,   /* COLLECT_EPSILON_LOOPS  */
    ZERO_PLUS = 296,               /* ZERO_PLUS  */
    INSPECT = 297,                 /* INSPECT  */
    ROTATE = 298,                  /* ROTATE  */
    PRINT_WORDS = 299,             /* PRINT_WORDS  */
    POP = 300,                     /* POP  */
    SAVE_SPACED = 301,             /* SAVE_SPACED  */
    DEFINE = 302,                  /* DEFINE  */
    SHOW = 303,                    /* SHOW  */
    PRINT_LONGEST_STRING_SIZE = 304, /* PRINT_LONGEST_STRING_SIZE  */
    TEST_EQ = 305,                 /* TEST_EQ  */
    SORT = 306,                    /* SORT  */
    SAVE_DEFINITIONS = 307,        /* SAVE_DEFINITIONS  */
    SAVE_DOT = 308,                /* SAVE_DOT  */
    TEST_UPPER_BOUNDED = 309,      /* TEST_UPPER_BOUNDED  */
    COMPLETE = 310,                /* COMPLETE  */
    PRINT_FILE_INFO = 311,         /* PRINT_FILE_INFO  */
    INTERSECT = 312,               /* INTERSECT  */
    END_SUB = 313,                 /* END_SUB  */
    TURN = 314,                    /* TURN  */
    PRINT_LIST = 315,              /* PRINT_LIST  */
    SUBSTITUTE_SYMBOL = 316,       /* SUBSTITUTE_SYMBOL  */
    APPLY_UP = 317,                /* APPLY_UP  */
    ONE_PLUS = 318,                /* ONE_PLUS  */
    UNDEFINE = 319,                /* UNDEFINE  */
    EPSILON_REMOVE = 320,          /* EPSILON_REMOVE  */
    PRINT_RANDOM_WORDS = 321,      /* PRINT_RANDOM_WORDS  */
    CTRLD = 322,                   /* CTRLD  */
    EXTRACT_UNAMBIGUOUS = 323,     /* EXTRACT_UNAMBIGUOUS  */
    SEMICOLON = 324,               /* SEMICOLON  */
    PRINT_LOWER_WORDS = 325,       /* PRINT_LOWER_WORDS  */
    READ_PROLOG = 326,             /* READ_PROLOG  */
    CLEAR = 327,                   /* CLEAR  */
    PRINT_SIGMA_COUNT = 328,       /* PRINT_SIGMA_COUNT  */
    SUBSTITUTE_NAMED = 329,        /* SUBSTITUTE_NAMED  */
    PRINT_FLAGS = 330,             /* PRINT_FLAGS  */
    SET = 331,                     /* SET  */
    NEGATE = 332,                  /* NEGATE  */
    APPLY_DOWN = 333,              /* APPLY_DOWN  */
    PRINT_STACK = 334,             /* PRINT_STACK  */
    SAVE_STACK = 335,              /* SAVE_STACK  */
    PUSH = 336,                    /* PUSH  */
    TEST_LOWER_BOUNDED = 337,      /* TEST_LOWER_BOUNDED  */
    PRINT_DEFINED = 338,           /* PRINT_DEFINED  */
    APPLY_MED = 339,               /* APPLY_MED  */
    SHOW_ALL = 340,                /* SHOW_ALL  */
    PRINT_ARCCOUNT = 341,          /* PRINT_ARCCOUNT  */
    PRINT_SIZE = 342,              /* PRINT_SIZE  */
    TEST_NULL = 343,               /* TEST_NULL  */
    PRINT_RANDOM_UPPER = 344,      /* PRINT_RANDOM_UPPER  */
    PRINT_LONGEST_STRING = 345,    /* PRINT_LONGEST_STRING  */
    UPPER_SIDE = 346,              /* UPPER_SIDE  */
    XFST_IGNORE = 347,             /* XFST_IGNORE  */
    TEST_UNAMBIGUOUS = 348,        /* TEST_UNAMBIGUOUS  */
    PRINT = 349,                   /* PRINT  */
    READ_TEXT = 350,               /* READ_TEXT  */
    UNLIST = 351,                  /* UNLIST  */
    SUBSTITUTE_LABEL = 352,        /* SUBSTITUTE_LABEL  */
    SAVE_DEFINITION = 353,         /* SAVE_DEFINITION  */
    ELIMINATE_FLAG = 354,          /* ELIMINATE_FLAG  */
    EDIT_PROPS = 355,              /* EDIT_PROPS  */
    PRINT_UPPER_WORDS = 356,       /* PRINT_UPPER_WORDS  */
    NAME = 357,                    /* NAME  */
    EXTRACT_AMBIGUOUS = 358,       /* EXTRACT_AMBIGUOUS  */
    DEFINE_ALIAS = 359,            /* DEFINE_ALIAS  */
    PRINT_RANDOM_LOWER = 360,      /* PRINT_RANDOM_LOWER  */
    CROSSPRODUCT = 361,            /* CROSSPRODUCT  */
    COMPACT_SIGMA = 362,           /* COMPACT_SIGMA  */
    SOURCE = 363,                  /* SOURCE  */
    AMBIGUOUS = 364,               /* AMBIGUOUS  */
    ELIMINATE_ALL = 365,           /* ELIMINATE_ALL  */
    PRINT_SIGMA = 366,             /* PRINT_SIGMA  */
    PRINT_SHORTEST_STRING = 367,   /* PRINT_SHORTEST_STRING  */
    LEFT_PAREN = 368,              /* LEFT_PAREN  */
    PRINT_PROPS = 369,             /* PRINT_PROPS  */
    READ_REGEX = 370,              /* READ_REGEX  */
    DEFINE_LIST = 371,             /* DEFINE_LIST  */
    TEST_ID = 372,                 /* TEST_ID  */
    PRINT_LISTS = 373,             /* PRINT_LISTS  */
    TEST_SUBLANGUAGE = 374,        /* TEST_SUBLANGUAGE  */
    TEST_LOWER_UNI = 375,          /* TEST_LOWER_UNI  */
    COMPILE_REPLACE_UPPER = 376,   /* COMPILE_REPLACE_UPPER  */
    CLEANUP = 377,                 /* CLEANUP  */
    ADD_PROPS = 378,               /* ADD_PROPS  */
    PRINT_SIGMA_WORD_COUNT = 379,  /* PRINT_SIGMA_WORD_COUNT  */
    SHUFFLE = 380,                 /* SHUFFLE  */
    COLON = 381,                   /* COLON  */
    SAVE_TEXT = 382,               /* SAVE_TEXT  */
    DETERMINIZE = 383,             /* DETERMINIZE  */
    SIGMA = 384,                   /* SIGMA  */
    COMPILE_REPLACE_LOWER = 385,   /* COMPILE_REPLACE_LOWER  */
    UNION = 386,                   /* UNION  */
    PRINT_DIR = 387,               /* PRINT_DIR  */
    LIST = 388,                    /* LIST  */
    LOWER_SIDE = 389,              /* LOWER_SIDE  */
    MINIMIZE = 390,                /* MINIMIZE  */
    MINUS = 391,                   /* MINUS  */
    PRINT_NAME = 392,              /* PRINT_NAME  */
    PRUNE_NET = 393,               /* PRUNE_NET  */
    PUSH_DEFINED = 394,            /* PUSH_DEFINED  */
    READ_LEXC = 395,               /* READ_LEXC  */
    READ_ATT = 396,                /* READ_ATT  */
    TWOSIDED_FLAGS = 397,          /* TWOSIDED_FLAGS  */
    WRITE_ATT = 398,               /* WRITE_ATT  */
    ASSERT = 399,                  /* ASSERT  */
    LABEL_NET = 400,               /* LABEL_NET  */
    LOOKUP_OPTIMIZE = 401,         /* LOOKUP_OPTIMIZE  */
    REMOVE_OPTIMIZATION = 402,     /* REMOVE_OPTIMIZATION  */
    TEST_INFINITELY_AMBIGUOUS = 403, /* TEST_INFINITELY_AMBIGUOUS  */
    XFST_ERROR = 404,              /* XFST_ERROR  */
    NEWLINE = 405,                 /* NEWLINE  */
    REGEX = 406,                   /* REGEX  */
    APPLY_INPUT = 407,             /* APPLY_INPUT  */
    APPLY_UP_SINGLE = 408,         /* APPLY_UP_SINGLE  */
    APPLY_DOWN_SINGLE = 409        /* APPLY_DOWN_SINGLE  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define APROPOS 258
#define DESCRIBE 259
#define ECHO_ 260
#define SYSTEM 261
#define QUIT 262
#define HFST 263
#define NAMETOKEN 264
#define NAMECHAR 265
#define GLOB 266
#define PROTOTYPE 267
#define DEFINE_NAME 268
#define DEFINE_FUNCTION 269
#define RANGE 270
#define REDIRECT_IN 271
#define REDIRECT_OUT 272
#define SAVE_PROLOG 273
#define FOR 274
#define REVERSE 275
#define VIEW 276
#define LOADD 277
#define PRINT_LABEL_COUNT 278
#define TEST_OVERLAP 279
#define TEST_NONNULL 280
#define CONCATENATE 281
#define LOADS 282
#define INVERT 283
#define PRINT_ALIASES 284
#define PRINT_LABELS 285
#define XFST_OPTIONAL 286
#define PRINT_SHORTEST_STRING_SIZE 287
#define READ_PROPS 288
#define TEST_FUNCT 289
#define PRINT_LABELMAPS 290
#define SUBSTRING 291
#define COMPOSE 292
#define READ_SPACED 293
#define TEST_UPPER_UNI 294
#define COLLECT_EPSILON_LOOPS 295
#define ZERO_PLUS 296
#define INSPECT 297
#define ROTATE 298
#define PRINT_WORDS 299
#define POP 300
#define SAVE_SPACED 301
#define DEFINE 302
#define SHOW 303
#define PRINT_LONGEST_STRING_SIZE 304
#define TEST_EQ 305
#define SORT 306
#define SAVE_DEFINITIONS 307
#define SAVE_DOT 308
#define TEST_UPPER_BOUNDED 309
#define COMPLETE 310
#define PRINT_FILE_INFO 311
#define INTERSECT 312
#define END_SUB 313
#define TURN 314
#define PRINT_LIST 315
#define SUBSTITUTE_SYMBOL 316
#define APPLY_UP 317
#define ONE_PLUS 318
#define UNDEFINE 319
#define EPSILON_REMOVE 320
#define PRINT_RANDOM_WORDS 321
#define CTRLD 322
#define EXTRACT_UNAMBIGUOUS 323
#define SEMICOLON 324
#define PRINT_LOWER_WORDS 325
#define READ_PROLOG 326
#define CLEAR 327
#define PRINT_SIGMA_COUNT 328
#define SUBSTITUTE_NAMED 329
#define PRINT_FLAGS 330
#define SET 331
#define NEGATE 332
#define APPLY_DOWN 333
#define PRINT_STACK 334
#define SAVE_STACK 335
#define PUSH 336
#define TEST_LOWER_BOUNDED 337
#define PRINT_DEFINED 338
#define APPLY_MED 339
#define SHOW_ALL 340
#define PRINT_ARCCOUNT 341
#define PRINT_SIZE 342
#define TEST_NULL 343
#define PRINT_RANDOM_UPPER 344
#define PRINT_LONGEST_STRING 345
#define UPPER_SIDE 346
#define XFST_IGNORE 347
#define TEST_UNAMBIGUOUS 348
#define PRINT 349
#define READ_TEXT 350
#define UNLIST 351
#define SUBSTITUTE_LABEL 352
#define SAVE_DEFINITION 353
#define ELIMINATE_FLAG 354
#define EDIT_PROPS 355
#define PRINT_UPPER_WORDS 356
#define NAME 357
#define EXTRACT_AMBIGUOUS 358
#define DEFINE_ALIAS 359
#define PRINT_RANDOM_LOWER 360
#define CROSSPRODUCT 361
#define COMPACT_SIGMA 362
#define SOURCE 363
#define AMBIGUOUS 364
#define ELIMINATE_ALL 365
#define PRINT_SIGMA 366
#define PRINT_SHORTEST_STRING 367
#define LEFT_PAREN 368
#define PRINT_PROPS 369
#define READ_REGEX 370
#define DEFINE_LIST 371
#define TEST_ID 372
#define PRINT_LISTS 373
#define TEST_SUBLANGUAGE 374
#define TEST_LOWER_UNI 375
#define COMPILE_REPLACE_UPPER 376
#define CLEANUP 377
#define ADD_PROPS 378
#define PRINT_SIGMA_WORD_COUNT 379
#define SHUFFLE 380
#define COLON 381
#define SAVE_TEXT 382
#define DETERMINIZE 383
#define SIGMA 384
#define COMPILE_REPLACE_LOWER 385
#define UNION 386
#define PRINT_DIR 387
#define LIST 388
#define LOWER_SIDE 389
#define MINIMIZE 390
#define MINUS 391
#define PRINT_NAME 392
#define PRUNE_NET 393
#define PUSH_DEFINED 394
#define READ_LEXC 395
#define READ_ATT 396
#define TWOSIDED_FLAGS 397
#define WRITE_ATT 398
#define ASSERT 399
#define LABEL_NET 400
#define LOOKUP_OPTIMIZE 401
#define REMOVE_OPTIMIZATION 402
#define TEST_INFINITELY_AMBIGUOUS 403
#define XFST_ERROR 404
#define NEWLINE 405
#define REGEX 406
#define APPLY_INPUT 407
#define APPLY_UP_SINGLE 408
#define APPLY_DOWN_SINGLE 409

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 51 "xfst-parser.yy"

    char* name;
    char* text;
    char** list;
    char* file;
    void* nothing;

#line 490 "xfst-parser.cc"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


extern YYSTYPE hxfstlval;
extern YYLTYPE hxfstlloc;

int hxfstparse (void);


#endif /* !YY_HXFST_XFST_PARSER_HH_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_APROPOS = 3,                    /* APROPOS  */
  YYSYMBOL_DESCRIBE = 4,                   /* DESCRIBE  */
  YYSYMBOL_ECHO_ = 5,                      /* ECHO_  */
  YYSYMBOL_SYSTEM = 6,                     /* SYSTEM  */
  YYSYMBOL_QUIT = 7,                       /* QUIT  */
  YYSYMBOL_HFST = 8,                       /* HFST  */
  YYSYMBOL_NAMETOKEN = 9,                  /* NAMETOKEN  */
  YYSYMBOL_NAMECHAR = 10,                  /* NAMECHAR  */
  YYSYMBOL_GLOB = 11,                      /* GLOB  */
  YYSYMBOL_PROTOTYPE = 12,                 /* PROTOTYPE  */
  YYSYMBOL_DEFINE_NAME = 13,               /* DEFINE_NAME  */
  YYSYMBOL_DEFINE_FUNCTION = 14,           /* DEFINE_FUNCTION  */
  YYSYMBOL_RANGE = 15,                     /* RANGE  */
  YYSYMBOL_REDIRECT_IN = 16,               /* REDIRECT_IN  */
  YYSYMBOL_REDIRECT_OUT = 17,              /* REDIRECT_OUT  */
  YYSYMBOL_SAVE_PROLOG = 18,               /* SAVE_PROLOG  */
  YYSYMBOL_FOR = 19,                       /* FOR  */
  YYSYMBOL_REVERSE = 20,                   /* REVERSE  */
  YYSYMBOL_VIEW = 21,                      /* VIEW  */
  YYSYMBOL_LOADD = 22,                     /* LOADD  */
  YYSYMBOL_PRINT_LABEL_COUNT = 23,         /* PRINT_LABEL_COUNT  */
  YYSYMBOL_TEST_OVERLAP = 24,              /* TEST_OVERLAP  */
  YYSYMBOL_TEST_NONNULL = 25,              /* TEST_NONNULL  */
  YYSYMBOL_CONCATENATE = 26,               /* CONCATENATE  */
  YYSYMBOL_LOADS = 27,                     /* LOADS  */
  YYSYMBOL_INVERT = 28,                    /* INVERT  */
  YYSYMBOL_PRINT_ALIASES = 29,             /* PRINT_ALIASES  */
  YYSYMBOL_PRINT_LABELS = 30,              /* PRINT_LABELS  */
  YYSYMBOL_XFST_OPTIONAL = 31,             /* XFST_OPTIONAL  */
  YYSYMBOL_PRINT_SHORTEST_STRING_SIZE = 32, /* PRINT_SHORTEST_STRING_SIZE  */
  YYSYMBOL_READ_PROPS = 33,                /* READ_PROPS  */
  YYSYMBOL_TEST_FUNCT = 34,                /* TEST_FUNCT  */
  YYSYMBOL_PRINT_LABELMAPS = 35,           /* PRINT_LABELMAPS  */
  YYSYMBOL_SUBSTRING = 36,                 /* SUBSTRING  */
  YYSYMBOL_COMPOSE = 37,                   /* COMPOSE  */
  YYSYMBOL_READ_SPACED = 38,               /* READ_SPACED  */
  YYSYMBOL_TEST_UPPER_UNI = 39,            /* TEST_UPPER_UNI  */
  YYSYMBOL_COLLECT_EPSILON_LOOPS = 40,     /* COLLECT_EPSILON_LOOPS  */
  YYSYMBOL_ZERO_PLUS = 41,                 /* ZERO_PLUS  */
  YYSYMBOL_INSPECT = 42,                   /* INSPECT  */
  YYSYMBOL_ROTATE = 43,                    /* ROTATE  */
  YYSYMBOL_PRINT_WORDS = 44,               /* PRINT_WORDS  */
  YYSYMBOL_POP = 45,                       /* POP  */
  YYSYMBOL_SAVE_SPACED = 46,               /* SAVE_SPACED  */
  YYSYMBOL_DEFINE = 47,                    /* DEFINE  */
  YYSYMBOL_SHOW = 48,                      /* SHOW  */
  YYSYMBOL_PRINT_LONGEST_STRING_SIZE = 49, /* PRINT_LONGEST_STRING_SIZE  */
  YYSYMBOL_TEST_EQ = 50,                   /* TEST_EQ  */
  YYSYMBOL_SORT = 51,                      /* SORT  */
  YYSYMBOL_SAVE_DEFINITIONS = 52,          /* SAVE_DEFINITIONS  */
  YYSYMBOL_SAVE_DOT = 53,                  /* SAVE_DOT  */
  YYSYMBOL_TEST_UPPER_BOUNDED = 54,        /* TEST_UPPER_BOUNDED  */
  YYSYMBOL_COMPLETE = 55,                  /* COMPLETE  */
  YYSYMBOL_PRINT_FILE_INFO = 56,           /* PRINT_FILE_INFO  */
  YYSYMBOL_INTERSECT = 57,                 /* INTERSECT  */
  YYSYMBOL_END_SUB = 58,                   /* END_SUB  */
  YYSYMBOL_TURN = 59,                      /* TURN  */
  YYSYMBOL_PRINT_LIST = 60,                /* PRINT_LIST  */
  YYSYMBOL_SUBSTITUTE_SYMBOL = 61,         /* SUBSTITUTE_SYMBOL  */
  YYSYMBOL_APPLY_UP = 62,                  /* APPLY_UP  */
  YYSYMBOL_ONE_PLUS = 63,                  /* ONE_PLUS  */
  YYSYMBOL_UNDEFINE = 64,                  /* UNDEFINE  */
  YYSYMBOL_EPSILON_REMOVE = 65,            /* EPSILON_REMOVE  */
  YYSYMBOL_PRINT_RANDOM_WORDS = 66,        /* PRINT_RANDOM_WORDS  */
  YYSYMBOL_CTRLD = 67,                     /* CTRLD  */
  YYSYMBOL_EXTRACT_UNAMBIGUOUS = 68,       /* EXTRACT_UNAMBIGUOUS  */
  YYSYMBOL_SEMICOLON = 69,                 /* SEMICOLON  */
  YYSYMBOL_PRINT_LOWER_WORDS = 70,         /* PRINT_LOWER_WORDS  */
  YYSYMBOL_READ_PROLOG = 71,               /* READ_PROLOG  */
  YYSYMBOL_CLEAR = 72,                     /* CLEAR  */
  YYSYMBOL_PRINT_SIGMA_COUNT = 73,         /* PRINT_SIGMA_COUNT  */
  YYSYMBOL_SUBSTITUTE_NAMED = 74,          /* SUBSTITUTE_NAMED  */
  YYSYMBOL_PRINT_FLAGS = 75,               /* PRINT_FLAGS  */
  YYSYMBOL_SET = 76,                       /* SET  */
  YYSYMBOL_NEGATE = 77,                    /* NEGATE  */
  YYSYMBOL_APPLY_DOWN = 78,                /* APPLY_DOWN  */
  YYSYMBOL_PRINT_STACK = 79,               /* PRINT_STACK  */
  YYSYMBOL_SAVE_STACK = 80,                /* SAVE_STACK  */
  YYSYMBOL_PUSH = 81,                      /* PUSH  */
  YYSYMBOL_TEST_LOWER_BOUNDED = 82,        /* TEST_LOWER_BOUNDED  */
  YYSYMBOL_PRINT_DEFINED = 83,             /* PRINT_DEFINED  */
  YYSYMBOL_APPLY_MED = 84,                 /* APPLY_MED  */
  YYSYMBOL_SHOW_ALL = 85,                  /* SHOW_ALL  */
  YYSYMBOL_PRINT_ARCCOUNT = 86,            /* PRINT_ARCCOUNT  */
  YYSYMBOL_PRINT_SIZE = 87,                /* PRINT_SIZE  */
  YYSYMBOL_TEST_NULL = 88,                 /* TEST_NULL  */
  YYSYMBOL_PRINT_RANDOM_UPPER = 89,        /* PRINT_RANDOM_UPPER  */
  YYSYMBOL_PRINT_LONGEST_STRING = 90,      /* PRINT_LONGEST_STRING  */
  YYSYMBOL_UPPER_SIDE = 91,                /* UPPER_SIDE  */
  YYSYMBOL_XFST_IGNORE = 92,               /* XFST_IGNORE  */
  YYSYMBOL_TEST_UNAMBIGUOUS = 93,          /* TEST_UNAMBIGUOUS  */
  YYSYMBOL_PRINT = 94,                     /* PRINT  */
  YYSYMBOL_READ_TEXT = 95,                 /* READ_TEXT  */
  YYSYMBOL_UNLIST = 96,                    /* UNLIST  */
  YYSYMBOL_SUBSTITUTE_LABEL = 97,          /* SUBSTITUTE_LABEL  */
  YYSYMBOL_SAVE_DEFINITION = 98,           /* SAVE_DEFINITION  */
  YYSYMBOL_ELIMINATE_FLAG = 99,            /* ELIMINATE_FLAG  */
  YYSYMBOL_EDIT_PROPS = 100,               /* EDIT_PROPS  */
  YYSYMBOL_PRINT_UPPER_WORDS = 101,        /* PRINT_UPPER_WORDS  */
  YYSYMBOL_NAME = 102,                     /* NAME  */
  YYSYMBOL_EXTRACT_AMBIGUOUS = 103,        /* EXTRACT_AMBIGUOUS  */
  YYSYMBOL_DEFINE_ALIAS = 104,             /* DEFINE_ALIAS  */
  YYSYMBOL_PRINT_RANDOM_LOWER = 105,       /* PRINT_RANDOM_LOWER  */
  YYSYMBOL_CROSSPRODUCT = 106,             /* CROSSPRODUCT  */
  YYSYMBOL_COMPACT_SIGMA = 107,            /* COMPACT_SIGMA  */
  YYSYMBOL_SOURCE = 108,                   /* SOURCE  */
  YYSYMBOL_AMBIGUOUS = 109,                /* AMBIGUOUS  */
  YYSYMBOL_ELIMINATE_ALL = 110,            /* ELIMINATE_ALL  */
  YYSYMBOL_PRINT_SIGMA = 111,              /* PRINT_SIGMA  */
  YYSYMBOL_PRINT_SHORTEST_STRING = 112,    /* PRINT_SHORTEST_STRING  */
  YYSYMBOL_LEFT_PAREN = 113,               /* LEFT_PAREN  */
  YYSYMBOL_PRINT_PROPS = 114,              /* PRINT_PROPS  */
  YYSYMBOL_READ_REGEX = 115,               /* READ_REGEX  */
  YYSYMBOL_DEFINE_LIST = 116,              /* DEFINE_LIST  */
  YYSYMBOL_TEST_ID = 117,                  /* TEST_ID  */
  YYSYMBOL_PRINT_LISTS = 118,              /* PRINT_LISTS  */
  YYSYMBOL_TEST_SUBLANGUAGE = 119,         /* TEST_SUBLANGUAGE  */
  YYSYMBOL_TEST_LOWER_UNI = 120,           /* TEST_LOWER_UNI  */
  YYSYMBOL_COMPILE_REPLACE_UPPER = 121,    /* COMPILE_REPLACE_UPPER  */
  YYSYMBOL_CLEANUP = 122,                  /* CLEANUP  */
  YYSYMBOL_ADD_PROPS = 123,                /* ADD_PROPS  */
  YYSYMBOL_PRINT_SIGMA_WORD_COUNT = 124,   /* PRINT_SIGMA_WORD_COUNT  */
  YYSYMBOL_SHUFFLE = 125,                  /* SHUFFLE  */
  YYSYMBOL_COLON = 126,                    /* COLON  */
  YYSYMBOL_SAVE_TEXT = 127,                /* SAVE_TEXT  */
  YYSYMBOL_DETERMINIZE = 128,              /* DETERMINIZE  */
  YYSYMBOL_SIGMA = 129,                    /* SIGMA  */
  YYSYMBOL_COMPILE_REPLACE_LOWER = 130,    /* COMPILE_REPLACE_LOWER  */
  YYSYMBOL_UNION = 131,                    /* UNION  */
  YYSYMBOL_PRINT_DIR = 132,                /* PRINT_DIR  */
  YYSYMBOL_LIST = 133,                     /* LIST  */
  YYSYMBOL_LOWER_SIDE = 134,               /* LOWER_SIDE  */
  YYSYMBOL_MINIMIZE = 135,                 /* MINIMIZE  */
  YYSYMBOL_MINUS = 136,                    /* MINUS  */
  YYSYMBOL_PRINT_NAME = 137,               /* PRINT_NAME  */
  YYSYMBOL_PRUNE_NET = 138,                /* PRUNE_NET  */
  YYSYMBOL_PUSH_DEFINED = 139,             /* PUSH_DEFINED  */
  YYSYMBOL_READ_LEXC = 140,                /* READ_LEXC  */
  YYSYMBOL_READ_ATT = 141,                 /* READ_ATT  */
  YYSYMBOL_TWOSIDED_FLAGS = 142,           /* TWOSIDED_FLAGS  */
  YYSYMBOL_WRITE_ATT = 143,                /* WRITE_ATT  */
  YYSYMBOL_ASSERT = 144,                   /* ASSERT  */
  YYSYMBOL_LABEL_NET = 145,                /* LABEL_NET  */
  YYSYMBOL_LOOKUP_OPTIMIZE = 146,          /* LOOKUP_OPTIMIZE  */
  YYSYMBOL_REMOVE_OPTIMIZATION = 147,      /* REMOVE_OPTIMIZATION  */
  YYSYMBOL_TEST_INFINITELY_AMBIGUOUS = 148, /* TEST_INFINITELY_AMBIGUOUS  */
  YYSYMBOL_XFST_ERROR = 149,               /* XFST_ERROR  */
  YYSYMBOL_NEWLINE = 150,                  /* NEWLINE  */
  YYSYMBOL_REGEX = 151,                    /* REGEX  */
  YYSYMBOL_APPLY_INPUT = 152,              /* APPLY_INPUT  */
  YYSYMBOL_APPLY_UP_SINGLE = 153,          /* APPLY_UP_SINGLE  */
  YYSYMBOL_APPLY_DOWN_SINGLE = 154,        /* APPLY_DOWN_SINGLE  */
  YYSYMBOL_YYACCEPT = 155,                 /* $accept  */
  YYSYMBOL_XFST_SCRIPT = 156,              /* XFST_SCRIPT  */
  YYSYMBOL_COMMAND_LIST = 157,             /* COMMAND_LIST  */
  YYSYMBOL_COMMAND = 158,                  /* COMMAND  */
  YYSYMBOL_END_COMMAND = 159,              /* END_COMMAND  */
  YYSYMBOL_COMMAND_SEQUENCE = 160,         /* COMMAND_SEQUENCE  */
  YYSYMBOL_NAMETOKEN_LIST = 161,           /* NAMETOKEN_LIST  */
  YYSYMBOL_QUOTED_NAMETOKEN_LIST = 162,    /* QUOTED_NAMETOKEN_LIST  */
  YYSYMBOL_LABEL = 163,                    /* LABEL  */
  YYSYMBOL_LABEL_LIST = 164                /* LABEL_LIST  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  350
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   851

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  155
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  10
/* YYNRULES -- Number of rules.  */
#define YYNRULES  262
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  539

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   409


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,    99,    99,   100,   103,   104,   107,   116,   120,   125,
     128,   131,   135,   144,   148,   151,   154,   158,   167,   171,
     175,   184,   188,   191,   195,   199,   203,   208,   213,   218,
     223,   230,   234,   239,   244,   248,   252,   256,   261,   265,
     269,   272,   275,   279,   282,   285,   288,   292,   296,   301,
     304,   308,   312,   316,   320,   325,   329,   334,   338,   344,
     353,   357,   360,   364,   367,   370,   373,   376,   379,   382,
     385,   388,   391,   394,   397,   400,   404,   407,   410,   413,
     416,   419,   422,   425,   428,   431,   434,   437,   441,   446,
     451,   457,   466,   469,   478,   488,   491,   500,   503,   512,
     516,   525,   528,   537,   540,   549,   552,   556,   565,   568,
     577,   580,   589,   593,   602,   605,   615,   620,   630,   635,
     644,   647,   657,   662,   672,   677,   681,   692,   701,   704,
     719,   729,   733,   744,   752,   755,   769,   779,   783,   794,
     802,   805,   818,   827,   831,   841,   849,   852,   865,   874,
     878,   888,   896,   899,   912,   921,   925,   935,   943,   946,
     959,   968,   972,   981,   984,   988,   991,  1000,  1004,  1013,
    1016,  1025,  1028,  1038,  1047,  1050,  1054,  1063,  1066,  1075,
    1078,  1088,  1092,  1101,  1104,  1108,  1112,  1116,  1120,  1123,
    1126,  1130,  1139,  1148,  1151,  1160,  1163,  1172,  1176,  1185,
    1188,  1197,  1200,  1204,  1213,  1217,  1221,  1225,  1229,  1233,
    1237,  1241,  1245,  1249,  1252,  1256,  1259,  1268,  1277,  1288,
    1291,  1294,  1297,  1300,  1303,  1306,  1309,  1312,  1315,  1318,
    1321,  1324,  1327,  1330,  1333,  1336,  1339,  1342,  1345,  1348,
    1351,  1354,  1357,  1360,  1363,  1366,  1369,  1372,  1375,  1378,
    1389,  1389,  1391,  1413,  1416,  1421,  1443,  1448,  1474,  1493,
    1497,  1502,  1524
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "APROPOS", "DESCRIBE",
  "ECHO_", "SYSTEM", "QUIT", "HFST", "NAMETOKEN", "NAMECHAR", "GLOB",
  "PROTOTYPE", "DEFINE_NAME", "DEFINE_FUNCTION", "RANGE", "REDIRECT_IN",
  "REDIRECT_OUT", "SAVE_PROLOG", "FOR", "REVERSE", "VIEW", "LOADD",
  "PRINT_LABEL_COUNT", "TEST_OVERLAP", "TEST_NONNULL", "CONCATENATE",
  "LOADS", "INVERT", "PRINT_ALIASES", "PRINT_LABELS", "XFST_OPTIONAL",
  "PRINT_SHORTEST_STRING_SIZE", "READ_PROPS", "TEST_FUNCT",
  "PRINT_LABELMAPS", "SUBSTRING", "COMPOSE", "READ_SPACED",
  "TEST_UPPER_UNI", "COLLECT_EPSILON_LOOPS", "ZERO_PLUS", "INSPECT",
  "ROTATE", "PRINT_WORDS", "POP", "SAVE_SPACED", "DEFINE", "SHOW",
  "PRINT_LONGEST_STRING_SIZE", "TEST_EQ", "SORT", "SAVE_DEFINITIONS",
  "SAVE_DOT", "TEST_UPPER_BOUNDED", "COMPLETE", "PRINT_FILE_INFO",
  "INTERSECT", "END_SUB", "TURN", "PRINT_LIST", "SUBSTITUTE_SYMBOL",
  "APPLY_UP", "ONE_PLUS", "UNDEFINE", "EPSILON_REMOVE",
  "PRINT_RANDOM_WORDS", "CTRLD", "EXTRACT_UNAMBIGUOUS", "SEMICOLON",
  "PRINT_LOWER_WORDS", "READ_PROLOG", "CLEAR", "PRINT_SIGMA_COUNT",
  "SUBSTITUTE_NAMED", "PRINT_FLAGS", "SET", "NEGATE", "APPLY_DOWN",
  "PRINT_STACK", "SAVE_STACK", "PUSH", "TEST_LOWER_BOUNDED",
  "PRINT_DEFINED", "APPLY_MED", "SHOW_ALL", "PRINT_ARCCOUNT", "PRINT_SIZE",
  "TEST_NULL", "PRINT_RANDOM_UPPER", "PRINT_LONGEST_STRING", "UPPER_SIDE",
  "XFST_IGNORE", "TEST_UNAMBIGUOUS", "PRINT", "READ_TEXT", "UNLIST",
  "SUBSTITUTE_LABEL", "SAVE_DEFINITION", "ELIMINATE_FLAG", "EDIT_PROPS",
  "PRINT_UPPER_WORDS", "NAME", "EXTRACT_AMBIGUOUS", "DEFINE_ALIAS",
  "PRINT_RANDOM_LOWER", "CROSSPRODUCT", "COMPACT_SIGMA", "SOURCE",
  "AMBIGUOUS", "ELIMINATE_ALL", "PRINT_SIGMA", "PRINT_SHORTEST_STRING",
  "LEFT_PAREN", "PRINT_PROPS", "READ_REGEX", "DEFINE_LIST", "TEST_ID",
  "PRINT_LISTS", "TEST_SUBLANGUAGE", "TEST_LOWER_UNI",
  "COMPILE_REPLACE_UPPER", "CLEANUP", "ADD_PROPS",
  "PRINT_SIGMA_WORD_COUNT", "SHUFFLE", "COLON", "SAVE_TEXT", "DETERMINIZE",
  "SIGMA", "COMPILE_REPLACE_LOWER", "UNION", "PRINT_DIR", "LIST",
  "LOWER_SIDE", "MINIMIZE", "MINUS", "PRINT_NAME", "PRUNE_NET",
  "PUSH_DEFINED", "READ_LEXC", "READ_ATT", "TWOSIDED_FLAGS", "WRITE_ATT",
  "ASSERT", "LABEL_NET", "LOOKUP_OPTIMIZE", "REMOVE_OPTIMIZATION",
  "TEST_INFINITELY_AMBIGUOUS", "XFST_ERROR", "NEWLINE", "REGEX",
  "APPLY_INPUT", "APPLY_UP_SINGLE", "APPLY_DOWN_SINGLE", "$accept",
  "XFST_SCRIPT", "COMMAND_LIST", "COMMAND", "END_COMMAND",
  "COMMAND_SEQUENCE", "NAMETOKEN_LIST", "QUOTED_NAMETOKEN_LIST", "LABEL",
  "LABEL_LIST", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-264)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     697,  -146,  -146,  -264,  -264,  -264,  -264,  -146,  -144,  -123,
       8,  -146,  -146,    28,    70,  -146,  -146,  -146,   357,  -146,
      82,    72,  -146,   149,    32,  -146,    35,  -146,  -146,   359,
    -146,  -146,  -146,  -146,  -146,   113,  -146,   156,    40,   171,
    -146,  -146,   181,   114,  -146,  -146,   213,  -146,  -146,    71,
      74,    44,  -146,   125,  -146,   128,  -146,   129,    53,  -146,
     222,   126,   226,   130,  -146,   146,   235,   147,  -146,   236,
     158,  -146,   152,   161,  -146,   167,   254,  -146,  -146,  -146,
     172,   368,   168,   182,   190,   193,  -146,   178,   227,  -146,
     348,   197,  -146,  -146,   365,  -146,  -146,   208,   275,   210,
      -4,  -146,   295,  -146,  -146,  -146,  -146,   374,   217,  -146,
     298,  -146,  -146,  -146,  -146,    -9,   369,  -146,  -146,  -146,
     302,  -146,    73,   370,   373,  -146,   237,   410,  -146,  -146,
    -146,  -264,  -264,  -146,  -146,   395,   545,  -264,  -264,  -264,
    -264,  -264,  -264,  -264,  -146,  -146,  -264,  -264,  -264,  -146,
    -146,  -264,  -264,  -264,  -264,   231,  -146,  -264,  -146,  -264,
    -146,  -146,  -264,  -264,  -146,  -264,  -146,  -264,  -264,  -146,
    -264,  -264,  -146,  -146,    75,  -264,  -264,  -264,  -264,  -264,
     241,  -146,  -264,  -264,  -146,  -264,  -146,  -146,  -264,  -264,
    -264,  -146,  -264,  -146,  -146,  -264,  -264,  -264,  -146,  -264,
    -264,  -264,   309,  -264,   346,  -146,  -146,   125,  -264,  -264,
      97,  -264,   256,  -146,  -264,  -264,   273,  -146,  -264,  -146,
    -264,  -264,  -146,  -264,   377,  -146,  -264,   388,  -264,  -146,
    -146,   125,  -146,  -264,  -146,  -264,  -146,  -264,  -146,  -146,
     125,  -264,  -146,  -146,  -264,  -146,  -146,  -264,  -264,   276,
    -146,  -264,  -146,  -264,  -264,  -264,  -264,  -146,  -146,  -264,
    -146,  -146,   141,  -146,   272,  -264,   352,   196,  -146,  -264,
     288,  -146,  -264,  -146,  -264,   127,   307,  -146,  -264,  -264,
    -264,  -146,  -264,  -264,  -146,  -146,  -264,  -146,  -264,  -146,
    -146,  -264,  -146,  -264,    84,  -264,  -146,  -264,  -264,  -264,
    -264,  -264,  -146,   143,  -146,  -146,  -264,  -264,  -146,  -264,
    -264,  -264,  -264,  -264,   327,  -146,  -264,   246,  -264,  -264,
    -264,  -146,  -264,  -264,  -146,  -264,   249,   343,  -146,  -264,
     131,  -146,  -264,  -146,  -146,  -146,  -146,  -146,  -146,  -146,
    -146,  -146,  -146,  -146,  -146,  -264,  -264,  -264,  -264,  -264,
    -264,  -264,  -264,  -264,  -264,  -264,  -264,  -146,  -264,  -264,
    -264,  -264,  -264,  -264,  -264,  -264,  -264,  -264,  -264,  -264,
     328,  -146,  -264,  -264,  -264,  -264,  -264,  -264,  -264,  -264,
    -264,  -146,  -264,  -264,   392,  -264,  -264,   142,  -264,   331,
    -146,  -264,  -264,   332,  -146,  -264,  -264,  -264,  -264,   393,
    -264,  -146,  -264,  -264,   350,  -264,  -264,  -264,  -264,  -264,
     353,  -264,  -264,  -264,  -264,   333,  -146,  -264,  -264,  -264,
    -264,  -264,  -264,  -264,  -264,  -264,   394,   182,  -264,  -146,
     334,  -264,  -264,   336,  -146,  -264,  -264,  -264,  -264,   125,
      57,   337,  -146,  -264,  -264,  -264,  -264,  -264,  -264,  -264,
    -264,  -264,  -146,  -264,  -264,  -264,  -264,  -264,  -264,  -146,
    -264,  -264,  -146,   106,  -264,  -264,  -146,  -264,  -264,  -264,
     396,  -264,  -264,  -264,  -264,  -264,  -264,  -264,  -264,  -264,
    -264,  -264,  -264,  -264,  -264,  -264,  -146,  -264,  -264,  -264,
    -146,  -264,  -146,  -264,  -264,  -146,  -264,  -264,  -146,  -264,
    -264,  -264,  -146,  -264,  -264,  -264,  -146,  -264,  -146,  -264,
    -146,  -264,  -264,   355,  -264,  -264,  -264,  -146,  -264,  -264,
    -264,  -264,  -264,  -146,  -264,  -146,  -264,  -264,  -264,  -264,
    -264,  -264,  -264,  -264,  -264,  -264,  -264,  -264,  -264
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
     251,   251,   251,    53,    57,    54,    55,   251,    31,     0,
     251,   251,   251,     0,   251,   251,   251,   251,     0,   251,
     251,   251,   251,   251,   251,   251,     0,   251,   251,     0,
     251,   251,   251,   251,   251,   251,   251,   251,     0,   251,
     251,   251,   251,   251,   251,   251,   251,   251,   251,     0,
       0,   251,   251,     0,   251,   251,   251,   251,   251,   251,
     251,     0,   251,     0,   251,   251,   251,     0,   251,   251,
       0,   251,   251,   251,   251,   251,   251,   251,   251,   251,
     251,     0,     0,     0,     0,     0,   251,   251,     0,   251,
       0,   251,   251,   251,     0,   251,   251,   251,   251,   251,
       0,   251,   251,   251,   251,   251,   251,     0,   251,   251,
     251,   251,   251,   251,   251,   251,     0,   251,   251,   251,
     251,   251,   251,     0,     0,   251,   251,     0,   251,   251,
     251,    66,   250,   251,   251,     0,     2,     5,   248,    38,
      39,   249,    32,    33,   251,   251,   193,   239,    58,   251,
     251,   110,    73,    71,   222,   251,   251,   232,   251,    92,
     251,   251,   108,   238,   251,   124,   251,   199,    64,   251,
     243,   221,   251,   251,     0,    70,    49,   237,   231,    45,
     251,   251,   152,    41,   251,   195,   251,   251,   118,    63,
     242,   251,   189,   251,   251,   183,    69,   220,   251,   103,
     230,    44,   251,   258,     0,   251,   251,     9,   236,   256,
     251,   227,   251,   251,   158,    26,   251,   251,   128,   251,
     201,    40,   251,   171,     0,   251,   105,     0,   235,   251,
     251,    14,   251,   179,   251,    67,   251,    97,   251,   251,
       0,    61,   251,   251,    95,   251,   251,   177,    72,   251,
     251,   146,   251,   116,   234,   229,    75,   251,   251,   163,
     251,   251,     0,   251,   260,   262,     0,   251,   251,     8,
     251,   251,   140,   251,    25,     0,   251,   251,   134,   224,
      50,   251,    24,    52,   251,   251,   169,   251,   122,   251,
     251,   165,   251,   202,     0,    65,   251,   114,    74,    68,
     247,   219,   251,     0,   251,   251,   174,   240,   251,   197,
     226,   241,   246,   244,   251,   251,   101,     0,   233,   225,
     223,   251,   120,   228,   251,    43,   251,     0,   251,    62,
     251,   251,   215,   251,   251,   251,   251,   251,   251,   251,
     251,   251,   251,   251,   251,   245,    22,    23,    11,    16,
       1,     3,     4,   192,   191,    37,   109,   251,    47,    46,
      91,   106,   107,   123,   198,   180,   206,   205,   255,   207,
     251,   251,   151,   154,   194,    60,   117,   188,   181,   182,
     102,   251,   112,   257,     0,    12,    10,     0,    34,   251,
     251,   157,   160,   251,   251,   127,   130,   200,   170,     0,
     104,   251,    17,    15,     0,   178,   190,    96,    19,    20,
       0,    94,    93,   175,   176,   251,   251,   145,   148,   115,
     161,   162,   209,   208,   210,    35,     0,     0,   261,   251,
     251,   187,    51,   251,   251,   139,   142,    36,   254,     0,
     251,   251,   251,   133,   136,    56,   167,   168,   121,   164,
     166,   203,   251,   113,     6,     7,   172,   173,   196,   251,
      99,   100,   251,     0,   119,    42,   251,   211,   213,   214,
       0,   217,   216,    85,    83,    77,    82,    76,    81,    79,
      84,    87,    78,    86,    80,    48,   251,   149,   153,   111,
     251,    13,   251,   155,   159,   251,   125,   129,   251,    59,
      18,    21,   251,   143,   147,   259,   251,   186,   251,   185,
     251,   137,   141,     0,   252,   253,    27,   251,   131,   135,
     204,    98,    30,   251,   212,   251,   150,    90,   156,   126,
      88,   144,    89,   184,   138,    28,   132,    29,   218
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -264,  -264,  -264,   271,    -1,  -264,   187,  -264,  -263,  -264
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,   135,   136,   137,   138,   440,   174,   204,   265,   266
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     139,   140,   314,   428,   132,   209,   141,   142,   315,   146,
     147,   148,   292,   151,   152,   153,   154,   144,   157,   159,
     162,   163,   165,   167,   168,   145,   170,   171,   143,   175,
     176,   177,   178,   179,   182,   183,   185,   149,   188,   189,
     190,   192,   195,   196,   197,   199,   200,   201,   166,   186,
     207,   208,   169,   211,   214,   215,   218,   220,   221,   223,
     205,   226,   219,   228,   231,   233,   514,   235,   237,   240,
     241,   244,   247,   248,   251,   253,   254,   255,   256,   259,
     202,   160,   324,   203,   368,   269,   272,   150,   274,   161,
     278,   279,   280,   368,   282,   283,   286,   288,   291,   158,
     295,   297,   298,   299,   300,   301,   368,   306,   307,   309,
     310,   311,   312,   313,   316,   368,   318,   319,   320,   322,
     323,   325,   180,   193,   329,   332,   515,   345,   346,   347,
     181,   194,   348,   349,   209,   224,   438,   212,   216,   227,
     470,   132,   369,   353,   354,   213,   217,   293,   355,   356,
     368,   368,   368,   452,   358,   359,   234,   360,   132,   361,
     362,   242,   229,   363,   506,   364,   164,   238,   365,   243,
     245,   366,   367,   184,   239,   523,   249,   263,   246,   372,
     373,   257,   132,   374,   250,   375,   376,   270,   187,   258,
     377,   264,   378,   379,   132,   271,   206,   380,   191,   267,
     491,   382,   268,   132,   385,   386,   276,   132,   424,   388,
     455,   391,   392,   429,   277,   395,   396,   284,   397,   289,
     132,   398,   132,   132,   400,   285,   304,   290,   402,   403,
     198,   405,   132,   406,   305,   407,   273,   408,   409,   222,
     210,   411,   412,   225,   413,   414,   330,   132,   417,   418,
     370,   419,   232,   236,   331,   209,   420,   421,   371,   422,
     423,   462,   425,   132,   132,   389,   431,   432,   262,   435,
     436,   252,   437,   390,   439,   443,   444,   132,   132,   132,
     445,   132,   393,   446,   447,   415,   448,   294,   449,   450,
     394,   451,   287,   416,   303,   453,   132,   433,   230,   132,
     357,   454,   132,   456,   457,   434,   132,   458,   132,   430,
     327,   132,   296,   460,   461,   308,   441,   132,   466,   321,
     464,   132,   132,   465,   442,   467,   381,   469,   132,   471,
     472,   132,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   459,   486,   132,   132,   492,   495,
     502,   508,   368,   510,   517,   383,   485,   275,   132,   368,
     132,   264,   368,   132,   368,   384,   155,   132,   172,   487,
     488,   427,   132,   156,   281,   173,   132,   260,   317,   326,
     489,   132,   328,   209,   261,   132,   132,   132,   493,   494,
     302,   132,   496,   497,   387,   350,   399,   401,   426,   132,
     499,   490,   498,   505,   132,   525,   132,   352,   500,     0,
     468,   501,     0,   535,   503,   504,     0,     0,   404,     0,
       0,     0,     0,   132,     0,   132,   132,   410,   507,   509,
       0,     0,   511,   512,   333,   334,     0,     0,   132,   516,
     518,   519,     0,     0,   335,   132,     0,     0,   132,   336,
       0,   520,   132,     0,     0,     0,     0,   132,   521,   132,
     337,   522,     0,     0,   338,   524,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   132,   132,     0,
       0,   132,   132,   132,   132,   526,   132,   132,     0,   527,
       0,   528,   339,     0,   529,     0,     0,   530,   340,     0,
       0,   531,     0,   341,   463,   532,     0,   533,     0,   534,
       0,     0,     0,     0,     0,     0,   536,     0,     0,     0,
       0,     0,   537,     0,   538,     0,     0,   342,     0,   343,
     344,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     1,     2,
       3,     4,     5,     6,     7,     0,     0,     0,     8,     9,
       0,     0,     0,    10,     0,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,     0,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,     0,    48,    49,    50,    51,    52,    53,
      54,    55,   351,    56,     0,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,   513,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,     0,    99,
     100,     0,   101,   102,   103,   104,   105,   106,   107,   108,
     109,     0,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,     0,   132,     0,     0,   133,   134,
       1,     2,     3,     4,     5,     6,     7,     0,     0,     0,
       8,     9,     0,     0,     0,    10,     0,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,     0,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,     0,    48,    49,    50,    51,
      52,    53,    54,    55,     0,    56,     0,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,     0,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
       0,    99,   100,     0,   101,   102,   103,   104,   105,   106,
     107,   108,   109,     0,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,     0,   132,     0,     0,
     133,   134
};

static const yytype_int16 yycheck[] =
{
       1,     2,    11,   266,   150,     9,     7,   151,    17,    10,
      11,    12,    16,    14,    15,    16,    17,     9,    19,    20,
      21,    22,    23,    24,    25,    17,    27,    28,   151,    30,
      31,    32,    33,    34,    35,    36,    37,     9,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    16,     9,
      51,    52,    17,    54,    55,    56,    57,    58,    59,    60,
      16,    62,     9,    64,    65,    66,     9,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
       9,     9,     9,     9,     9,    86,    87,    17,    89,    17,
      91,    92,    93,     9,    95,    96,    97,    98,    99,    17,
     101,   102,   103,   104,   105,   106,     9,   108,   109,   110,
     111,   112,   113,   114,   115,     9,   117,   118,   119,   120,
     121,   122,     9,     9,   125,   126,    69,   128,   129,   130,
      17,    17,   133,   134,     9,     9,     9,     9,     9,     9,
       9,   150,    67,   144,   145,    17,    17,   151,   149,   150,
       9,     9,     9,    69,   155,   156,     9,   158,   150,   160,
     161,     9,    16,   164,   427,   166,    17,     9,   169,    17,
       9,   172,   173,    17,    16,    69,     9,     9,    17,   180,
     181,     9,   150,   184,    17,   186,   187,     9,    17,    17,
     191,     9,   193,   194,   150,    17,   152,   198,    17,     9,
      58,   202,     9,   150,   205,   206,     9,   150,    67,   210,
      67,   212,   213,    17,    17,   216,   217,     9,   219,     9,
     150,   222,   150,   150,   225,    17,     9,    17,   229,   230,
      17,   232,   150,   234,    17,   236,     9,   238,   239,    17,
      53,   242,   243,    17,   245,   246,     9,   150,   249,   250,
       9,   252,    17,    17,    17,     9,   257,   258,    17,   260,
     261,    15,   263,   150,   150,     9,   267,   268,    81,   270,
     271,    17,   273,    17,   275,   276,   277,   150,   150,   150,
     281,   150,     9,   284,   285,     9,   287,   100,   289,   290,
      17,   292,    17,    17,   107,   296,   150,     9,   152,   150,
      69,   302,   150,   304,   305,    17,   150,   308,   150,   113,
     123,   150,    17,   314,   315,    17,     9,   150,    69,    17,
     321,   150,   150,   324,    17,   326,    17,   328,   150,   330,
     331,   150,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,    17,    17,   150,   150,    17,    17,
      17,    17,     9,    17,    17,     9,   357,     9,   150,     9,
     150,     9,     9,   150,     9,    19,     9,   150,     9,   370,
     371,    19,   150,    16,     9,    16,   150,     9,     9,     9,
     381,   150,     9,     9,    16,   150,   150,   150,   389,   390,
      16,   150,   393,   394,   207,     0,    19,     9,   126,   150,
     401,     9,     9,     9,   150,     9,   150,   136,    58,    -1,
      67,    58,    -1,    58,   415,   416,    -1,    -1,   231,    -1,
      -1,    -1,    -1,   150,    -1,   150,   150,   240,   429,   430,
      -1,    -1,   433,   434,    24,    25,    -1,    -1,   150,   440,
     441,   442,    -1,    -1,    34,   150,    -1,    -1,   150,    39,
      -1,   452,   150,    -1,    -1,    -1,    -1,   150,   459,   150,
      50,   462,    -1,    -1,    54,   466,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   150,   150,    -1,
      -1,   150,   150,   150,   150,   486,   150,   150,    -1,   490,
      -1,   492,    82,    -1,   495,    -1,    -1,   498,    88,    -1,
      -1,   502,    -1,    93,   317,   506,    -1,   508,    -1,   510,
      -1,    -1,    -1,    -1,    -1,    -1,   517,    -1,    -1,    -1,
      -1,    -1,   523,    -1,   525,    -1,    -1,   117,    -1,   119,
     120,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,
       5,     6,     7,     8,     9,    -1,    -1,    -1,    13,    14,
      -1,    -1,    -1,    18,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    -1,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    -1,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,   439,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,    -1,   114,
     115,    -1,   117,   118,   119,   120,   121,   122,   123,   124,
     125,    -1,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,    -1,   150,    -1,    -1,   153,   154,
       3,     4,     5,     6,     7,     8,     9,    -1,    -1,    -1,
      13,    14,    -1,    -1,    -1,    18,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    -1,    59,    60,    61,    62,
      63,    64,    65,    66,    -1,    68,    -1,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
      -1,   114,   115,    -1,   117,   118,   119,   120,   121,   122,
     123,   124,   125,    -1,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,    -1,   150,    -1,    -1,
     153,   154
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,     5,     6,     7,     8,     9,    13,    14,
      18,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    59,    60,
      61,    62,    63,    64,    65,    66,    68,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   114,
     115,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   150,   153,   154,   156,   157,   158,   159,   159,
     159,   159,   151,   151,     9,    17,   159,   159,   159,     9,
      17,   159,   159,   159,   159,     9,    16,   159,    17,   159,
       9,    17,   159,   159,    17,   159,    16,   159,   159,    17,
     159,   159,     9,    16,   161,   159,   159,   159,   159,   159,
       9,    17,   159,   159,    17,   159,     9,    17,   159,   159,
     159,    17,   159,     9,    17,   159,   159,   159,    17,   159,
     159,   159,     9,     9,   162,    16,   152,   159,   159,     9,
     161,   159,     9,    17,   159,   159,     9,    17,   159,     9,
     159,   159,    17,   159,     9,    17,   159,     9,   159,    16,
     152,   159,    17,   159,     9,   159,    17,   159,     9,    16,
     159,   159,     9,    17,   159,     9,    17,   159,   159,     9,
      17,   159,    17,   159,   159,   159,   159,     9,    17,   159,
       9,    16,   161,     9,     9,   163,   164,     9,     9,   159,
       9,    17,   159,     9,   159,     9,     9,    17,   159,   159,
     159,     9,   159,   159,     9,    17,   159,    17,   159,     9,
      17,   159,    16,   151,   161,   159,    17,   159,   159,   159,
     159,   159,    16,   161,     9,    17,   159,   159,    17,   159,
     159,   159,   159,   159,    11,    17,   159,     9,   159,   159,
     159,    17,   159,   159,     9,   159,     9,   161,     9,   159,
       9,    17,   159,    24,    25,    34,    39,    50,    54,    82,
      88,    93,   117,   119,   120,   159,   159,   159,   159,   159,
       0,    67,   158,   159,   159,   159,   159,    69,   159,   159,
     159,   159,   159,   159,   159,   159,   159,   159,     9,    67,
       9,    17,   159,   159,   159,   159,   159,   159,   159,   159,
     159,    17,   159,     9,    19,   159,   159,   161,   159,     9,
      17,   159,   159,     9,    17,   159,   159,   159,   159,    19,
     159,     9,   159,   159,   161,   159,   159,   159,   159,   159,
     161,   159,   159,   159,   159,     9,    17,   159,   159,   159,
     159,   159,   159,   159,    67,   159,   126,    19,   163,    17,
     113,   159,   159,     9,    17,   159,   159,   159,     9,   159,
     160,     9,    17,   159,   159,   159,   159,   159,   159,   159,
     159,   159,    69,   159,   159,    67,   159,   159,   159,    17,
     159,   159,    15,   161,   159,   159,    69,   159,    67,   159,
       9,   159,   159,   159,   159,   159,   159,   159,   159,   159,
     159,   159,   159,   159,   159,   159,    17,   159,   159,   159,
       9,    58,    17,   159,   159,    17,   159,   159,     9,   159,
      58,    58,    17,   159,   159,     9,   163,   159,    17,   159,
      17,   159,   159,   161,     9,    69,   159,    17,   159,   159,
     159,   159,   159,    69,   159,     9,   159,   159,   159,   159,
     159,   159,   159,   159,   159,    58,   159,   159,   159
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_uint8 yyr1[] =
{
       0,   155,   156,   156,   157,   157,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     159,   159,   160,   160,   160,   161,   161,   162,   162,   163,
     163,   164,   164
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     2,     1,     3,     3,     2,     2,
       3,     2,     3,     4,     2,     3,     2,     3,     4,     3,
       3,     4,     2,     2,     2,     2,     2,     4,     5,     5,
       4,     1,     2,     2,     3,     3,     3,     3,     2,     2,
       2,     2,     3,     2,     2,     2,     3,     3,     4,     2,
       2,     3,     2,     1,     1,     1,     3,     1,     2,     4,
       3,     2,     2,     2,     2,     2,     1,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     5,     5,
       5,     3,     2,     3,     3,     2,     3,     2,     4,     3,
       3,     2,     3,     2,     3,     2,     3,     3,     2,     3,
       2,     4,     3,     3,     2,     3,     2,     3,     2,     3,
       2,     3,     2,     3,     2,     4,     5,     3,     2,     4,
       3,     4,     5,     3,     2,     4,     3,     4,     5,     3,
       2,     4,     3,     4,     5,     3,     2,     4,     3,     4,
       5,     3,     2,     4,     3,     4,     5,     3,     2,     4,
       3,     3,     3,     2,     3,     2,     3,     3,     3,     2,
       3,     2,     3,     3,     2,     3,     3,     2,     3,     2,
       3,     3,     3,     2,     5,     4,     4,     3,     3,     2,
       3,     3,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     2,     3,     4,     3,     3,     3,     3,     3,
       3,     3,     4,     3,     3,     2,     3,     3,     5,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     1,     2,
       1,     0,     2,     2,     1,     2,     1,     2,     1,     3,
       1,     2,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YYLOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YYLOCATION_PRINT

#  if defined YY_LOCATION_PRINT

   /* Temporary convenience wrapper in case some people defined the
      undocumented and private YY_LOCATION_PRINT macros.  */
#   define YYLOCATION_PRINT(File, Loc)  YY_LOCATION_PRINT(File, *(Loc))

#  elif defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
}

#   define YYLOCATION_PRINT  yy_location_print_

    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT(File, Loc)  YYLOCATION_PRINT(File, &(Loc))

#  else

#   define YYLOCATION_PRINT(File, Loc) ((void) 0)
    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT  YYLOCATION_PRINT

#  endif
# endif /* !defined YYLOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YYLOCATION_PRINT (yyo, yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
  YYLTYPE *yylloc;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 6: /* COMMAND: ADD_PROPS REDIRECT_IN END_COMMAND  */
#line 107 "xfst-parser.yy"
                                           {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              FILE * f = hfst::xfst::xfst_->xfst_fopen((yyvsp[-1].file), "r"); CHECK;
              hfst::xfst::xfst_->add_props(f);
              hfst::xfst::xfst_->xfst_fclose(f, (yyvsp[-1].file));
	    }
	    CHECK;
       }
#line 2486 "xfst-parser.cc"
    break;

  case 7: /* COMMAND: ADD_PROPS NAMETOKEN_LIST CTRLD  */
#line 116 "xfst-parser.yy"
                                        {
            hfst::xfst::xfst_->add_props((yyvsp[-1].text));
            free((yyvsp[-1].text)); CHECK;
       }
#line 2495 "xfst-parser.cc"
    break;

  case 8: /* COMMAND: EDIT_PROPS END_COMMAND  */
#line 120 "xfst-parser.yy"
                                {
            hxfsterror("NETWORK PROPERTY EDITOR unimplemented\n");
            return EXIT_FAILURE;
       }
#line 2504 "xfst-parser.cc"
    break;

  case 9: /* COMMAND: APPLY_UP END_COMMAND  */
#line 125 "xfst-parser.yy"
                              {
       	    hfst::xfst::xfst_->apply_up(stdin); CHECK;
       }
#line 2512 "xfst-parser.cc"
    break;

  case 10: /* COMMAND: APPLY_UP APPLY_INPUT END_COMMAND  */
#line 128 "xfst-parser.yy"
                                          {
       	    hfst::xfst::xfst_->apply_up((yyvsp[-1].text)); CHECK; free((yyvsp[-1].text));
       }
#line 2520 "xfst-parser.cc"
    break;

  case 11: /* COMMAND: APPLY_UP_SINGLE END_COMMAND  */
#line 131 "xfst-parser.yy"
                                     {
            hfst::xfst::xfst_->apply_up((yyvsp[-1].text));
            free((yyvsp[-1].text)); CHECK;
       }
#line 2529 "xfst-parser.cc"
    break;

  case 12: /* COMMAND: APPLY_UP REDIRECT_IN END_COMMAND  */
#line 135 "xfst-parser.yy"
                                          {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              FILE * f = hfst::xfst::xfst_->xfst_fopen((yyvsp[-1].file), "r"); CHECK;
              hfst::xfst::xfst_->apply_up(f);
              hfst::xfst::xfst_->xfst_fclose(f, (yyvsp[-1].file));
	    }
	    CHECK;
       }
#line 2543 "xfst-parser.cc"
    break;

  case 13: /* COMMAND: APPLY_UP END_COMMAND NAMETOKEN_LIST END_SUB  */
#line 144 "xfst-parser.yy"
                                                     {
            hfst::xfst::xfst_->apply_up((yyvsp[-1].text));
            free((yyvsp[-1].text)); CHECK;
       }
#line 2552 "xfst-parser.cc"
    break;

  case 14: /* COMMAND: APPLY_DOWN END_COMMAND  */
#line 148 "xfst-parser.yy"
                                {
            hfst::xfst::xfst_->apply_down(stdin); CHECK;
       }
#line 2560 "xfst-parser.cc"
    break;

  case 15: /* COMMAND: APPLY_DOWN APPLY_INPUT END_COMMAND  */
#line 151 "xfst-parser.yy"
                                            {
       	    hfst::xfst::xfst_->apply_down((yyvsp[-1].text)); CHECK; free((yyvsp[-1].text));
       }
#line 2568 "xfst-parser.cc"
    break;

  case 16: /* COMMAND: APPLY_DOWN_SINGLE END_COMMAND  */
#line 154 "xfst-parser.yy"
                                       {
            hfst::xfst::xfst_->apply_down((yyvsp[-1].text));
            free((yyvsp[-1].text)); CHECK;
       }
#line 2577 "xfst-parser.cc"
    break;

  case 17: /* COMMAND: APPLY_DOWN REDIRECT_IN END_COMMAND  */
#line 158 "xfst-parser.yy"
                                            {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              FILE * f = hfst::xfst::xfst_->xfst_fopen((yyvsp[-1].file), "r"); CHECK;
              hfst::xfst::xfst_->apply_down(f);
              hfst::xfst::xfst_->xfst_fclose(f, (yyvsp[-1].file));
	    }
	    CHECK;
       }
#line 2591 "xfst-parser.cc"
    break;

  case 18: /* COMMAND: APPLY_DOWN END_COMMAND NAMETOKEN_LIST END_SUB  */
#line 167 "xfst-parser.yy"
                                                       {
            hfst::xfst::xfst_->apply_down((yyvsp[-1].text));
            free((yyvsp[-1].text)); CHECK;
       }
#line 2600 "xfst-parser.cc"
    break;

  case 19: /* COMMAND: APPLY_MED NAMETOKEN END_COMMAND  */
#line 171 "xfst-parser.yy"
                                         {
            hfst::xfst::xfst_->apply_med((yyvsp[-1].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 2609 "xfst-parser.cc"
    break;

  case 20: /* COMMAND: APPLY_MED REDIRECT_IN END_COMMAND  */
#line 175 "xfst-parser.yy"
                                           {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              FILE * f = hfst::xfst::xfst_->xfst_fopen((yyvsp[-1].file), "r"); CHECK;
              hfst::xfst::xfst_->apply_med(f);
              hfst::xfst::xfst_->xfst_fclose(f, (yyvsp[-1].file));
	    }
	    CHECK;
       }
#line 2623 "xfst-parser.cc"
    break;

  case 21: /* COMMAND: APPLY_MED END_COMMAND NAMETOKEN_LIST END_SUB  */
#line 184 "xfst-parser.yy"
                                                      {
            hfst::xfst::xfst_->apply_med((yyvsp[-1].text));
            free((yyvsp[-1].text)); CHECK;
       }
#line 2632 "xfst-parser.cc"
    break;

  case 22: /* COMMAND: LOOKUP_OPTIMIZE END_COMMAND  */
#line 188 "xfst-parser.yy"
                                     {
            hfst::xfst::xfst_->lookup_optimize(); CHECK;
       }
#line 2640 "xfst-parser.cc"
    break;

  case 23: /* COMMAND: REMOVE_OPTIMIZATION END_COMMAND  */
#line 191 "xfst-parser.yy"
                                         {
            hfst::xfst::xfst_->remove_optimization(); CHECK;
       }
#line 2648 "xfst-parser.cc"
    break;

  case 24: /* COMMAND: AMBIGUOUS END_COMMAND  */
#line 195 "xfst-parser.yy"
                               {
            hxfsterror("unimplemetend ambiguous\n");
            return EXIT_FAILURE;
       }
#line 2657 "xfst-parser.cc"
    break;

  case 25: /* COMMAND: EXTRACT_AMBIGUOUS END_COMMAND  */
#line 199 "xfst-parser.yy"
                                       {
            hxfsterror("unimplemetend ambiguous\n");
            return EXIT_FAILURE;
       }
#line 2666 "xfst-parser.cc"
    break;

  case 26: /* COMMAND: EXTRACT_UNAMBIGUOUS END_COMMAND  */
#line 203 "xfst-parser.yy"
                                         {
            hxfsterror("unimplemetend ambiguous\n");
            return EXIT_FAILURE;
       }
#line 2675 "xfst-parser.cc"
    break;

  case 27: /* COMMAND: DEFINE_ALIAS NAMETOKEN COMMAND_SEQUENCE END_COMMAND  */
#line 208 "xfst-parser.yy"
                                                            {
            hfst::xfst::xfst_->define_alias((yyvsp[-2].name), (yyvsp[-1].text));
            free((yyvsp[-2].name));
            free((yyvsp[-1].text)); CHECK;
       }
#line 2685 "xfst-parser.cc"
    break;

  case 28: /* COMMAND: DEFINE_ALIAS NAMETOKEN END_COMMAND NAMETOKEN_LIST END_SUB  */
#line 213 "xfst-parser.yy"
                                                                   {
            hfst::xfst::xfst_->define_alias((yyvsp[-3].name), (yyvsp[-1].text));
            free((yyvsp[-3].name));
            free((yyvsp[-1].text)); CHECK;
       }
#line 2695 "xfst-parser.cc"
    break;

  case 29: /* COMMAND: LIST NAMETOKEN NAMETOKEN_LIST SEMICOLON END_COMMAND  */
#line 218 "xfst-parser.yy"
                                                             {
            hfst::xfst::xfst_->define_list((yyvsp[-3].name), (yyvsp[-2].text));
            free((yyvsp[-3].name));
            free((yyvsp[-2].text)); CHECK;
       }
#line 2705 "xfst-parser.cc"
    break;

  case 30: /* COMMAND: LIST NAMETOKEN RANGE END_COMMAND  */
#line 223 "xfst-parser.yy"
                                          {
            hfst::xfst::xfst_->define_list((yyvsp[-2].name), (yyvsp[-1].list)[0], (yyvsp[-1].list)[1]);
            free((yyvsp[-2].name));
            free((yyvsp[-1].list)[0]);
            free((yyvsp[-1].list)[1]);
            free((yyvsp[-1].list)); CHECK;
       }
#line 2717 "xfst-parser.cc"
    break;

  case 31: /* COMMAND: DEFINE_NAME  */
#line 230 "xfst-parser.yy"
                     {
            hfst::xfst::xfst_->define((yyvsp[0].name));
            free((yyvsp[0].name)); CHECK;
       }
#line 2726 "xfst-parser.cc"
    break;

  case 32: /* COMMAND: DEFINE_NAME REGEX  */
#line 234 "xfst-parser.yy"
                           {
            hfst::xfst::xfst_->define((yyvsp[-1].name), (yyvsp[0].text));
            free((yyvsp[-1].name));
            free((yyvsp[0].text)); CHECK;
       }
#line 2736 "xfst-parser.cc"
    break;

  case 33: /* COMMAND: DEFINE_FUNCTION REGEX  */
#line 239 "xfst-parser.yy"
                               {
            hfst::xfst::xfst_->define_function((yyvsp[-1].name), (yyvsp[0].text));
            free((yyvsp[-1].name));
            free((yyvsp[0].text)); CHECK;
       }
#line 2746 "xfst-parser.cc"
    break;

  case 34: /* COMMAND: UNDEFINE NAMETOKEN_LIST END_COMMAND  */
#line 244 "xfst-parser.yy"
                                             {
            hfst::xfst::xfst_->undefine((yyvsp[-1].text));
            free((yyvsp[-1].text)); CHECK;
       }
#line 2755 "xfst-parser.cc"
    break;

  case 35: /* COMMAND: UNLIST NAMETOKEN END_COMMAND  */
#line 248 "xfst-parser.yy"
                                      {
            hfst::xfst::xfst_->unlist((yyvsp[-1].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 2764 "xfst-parser.cc"
    break;

  case 36: /* COMMAND: NAME NAMETOKEN END_COMMAND  */
#line 252 "xfst-parser.yy"
                                    {
            hfst::xfst::xfst_->name_net((yyvsp[-1].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 2773 "xfst-parser.cc"
    break;

  case 37: /* COMMAND: LOADD NAMETOKEN END_COMMAND  */
#line 256 "xfst-parser.yy"
                                     {
            hfst::xfst::xfst_->load_definitions((yyvsp[-1].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 2782 "xfst-parser.cc"
    break;

  case 38: /* COMMAND: APROPOS END_COMMAND  */
#line 261 "xfst-parser.yy"
                             {
            hfst::xfst::xfst_->apropos((yyvsp[-1].text));
            free((yyvsp[-1].text)); CHECK;
       }
#line 2791 "xfst-parser.cc"
    break;

  case 39: /* COMMAND: DESCRIBE END_COMMAND  */
#line 265 "xfst-parser.yy"
                              {
            hfst::xfst::xfst_->describe((yyvsp[-1].text)); CHECK;
       }
#line 2799 "xfst-parser.cc"
    break;

  case 40: /* COMMAND: CLEAR END_COMMAND  */
#line 269 "xfst-parser.yy"
                           {
            hfst::xfst::xfst_->clear(); CHECK;
       }
#line 2807 "xfst-parser.cc"
    break;

  case 41: /* COMMAND: POP END_COMMAND  */
#line 272 "xfst-parser.yy"
                         {
            hfst::xfst::xfst_->pop(); CHECK;
       }
#line 2815 "xfst-parser.cc"
    break;

  case 42: /* COMMAND: PUSH_DEFINED NAMETOKEN END_COMMAND  */
#line 275 "xfst-parser.yy"
                                            {
            hfst::xfst::xfst_->push((yyvsp[-1].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 2824 "xfst-parser.cc"
    break;

  case 43: /* COMMAND: PUSH_DEFINED END_COMMAND  */
#line 279 "xfst-parser.yy"
                                  {
            hfst::xfst::xfst_->push(); CHECK;
       }
#line 2832 "xfst-parser.cc"
    break;

  case 44: /* COMMAND: TURN END_COMMAND  */
#line 282 "xfst-parser.yy"
                          {
            hfst::xfst::xfst_->turn(); CHECK;
       }
#line 2840 "xfst-parser.cc"
    break;

  case 45: /* COMMAND: ROTATE END_COMMAND  */
#line 285 "xfst-parser.yy"
                            {
            hfst::xfst::xfst_->rotate(); CHECK;
       }
#line 2848 "xfst-parser.cc"
    break;

  case 46: /* COMMAND: LOADS REDIRECT_IN END_COMMAND  */
#line 288 "xfst-parser.yy"
                                       {
            hfst::xfst::xfst_->load_stack((yyvsp[-1].file));
            free((yyvsp[-1].file)); CHECK;
       }
#line 2857 "xfst-parser.cc"
    break;

  case 47: /* COMMAND: LOADS NAMETOKEN END_COMMAND  */
#line 292 "xfst-parser.yy"
                                     {
            hfst::xfst::xfst_->load_stack((yyvsp[-1].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 2866 "xfst-parser.cc"
    break;

  case 48: /* COMMAND: LOADS NAMETOKEN SEMICOLON END_COMMAND  */
#line 296 "xfst-parser.yy"
                                               {
            hfst::xfst::xfst_->load_stack((yyvsp[-2].name));
            free((yyvsp[-2].name)); CHECK;
       }
#line 2875 "xfst-parser.cc"
    break;

  case 49: /* COMMAND: COLLECT_EPSILON_LOOPS END_COMMAND  */
#line 301 "xfst-parser.yy"
                                           {
            hfst::xfst::xfst_->collect_epsilon_loops(); CHECK;
       }
#line 2883 "xfst-parser.cc"
    break;

  case 50: /* COMMAND: COMPACT_SIGMA END_COMMAND  */
#line 304 "xfst-parser.yy"
                                   {
            hfst::xfst::xfst_->compact_sigma(); CHECK;
       }
#line 2891 "xfst-parser.cc"
    break;

  case 51: /* COMMAND: ELIMINATE_FLAG NAMETOKEN END_COMMAND  */
#line 308 "xfst-parser.yy"
                                              {
            hfst::xfst::xfst_->eliminate_flag((yyvsp[-1].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 2900 "xfst-parser.cc"
    break;

  case 52: /* COMMAND: ELIMINATE_ALL END_COMMAND  */
#line 312 "xfst-parser.yy"
                                   {
            hfst::xfst::xfst_->eliminate_flags(); CHECK;
       }
#line 2908 "xfst-parser.cc"
    break;

  case 53: /* COMMAND: ECHO_  */
#line 316 "xfst-parser.yy"
               {
            hfst::xfst::xfst_->echo((yyvsp[0].text));
            free((yyvsp[0].text)); CHECK;
       }
#line 2917 "xfst-parser.cc"
    break;

  case 54: /* COMMAND: QUIT  */
#line 320 "xfst-parser.yy"
              {
            hfst::xfst::xfst_->quit((yyvsp[0].text));
            free((yyvsp[0].text));
            return EXIT_SUCCESS;
       }
#line 2927 "xfst-parser.cc"
    break;

  case 55: /* COMMAND: HFST  */
#line 325 "xfst-parser.yy"
              {
            hfst::xfst::xfst_->hfst((yyvsp[0].text));
            free((yyvsp[0].text)); CHECK;
       }
#line 2936 "xfst-parser.cc"
    break;

  case 56: /* COMMAND: SOURCE NAMETOKEN END_COMMAND  */
#line 329 "xfst-parser.yy"
                                      {
            hxfsterror("source not implemented yywrap\n");
            free((yyvsp[-1].name));
            return EXIT_FAILURE;
       }
#line 2946 "xfst-parser.cc"
    break;

  case 57: /* COMMAND: SYSTEM  */
#line 334 "xfst-parser.yy"
                {
            hfst::xfst::xfst_->system((yyvsp[0].text));
            free((yyvsp[0].text)); CHECK;
       }
#line 2955 "xfst-parser.cc"
    break;

  case 58: /* COMMAND: VIEW END_COMMAND  */
#line 338 "xfst-parser.yy"
                          {
            hfst::xfst::xfst_->view_net(); CHECK;
            //hxfsterror("view not implemented\n");
            //return EXIT_FAILURE;
       }
#line 2965 "xfst-parser.cc"
    break;

  case 59: /* COMMAND: SET NAMETOKEN NAMETOKEN END_COMMAND  */
#line 344 "xfst-parser.yy"
                                             {
            int i = hfst::xfst::nametoken_to_number((yyvsp[-1].name));
            if (i != -1)
              hfst::xfst::xfst_->set((yyvsp[-2].name), i);
            else
              hfst::xfst::xfst_->set((yyvsp[-2].name), (yyvsp[-1].name));
            free((yyvsp[-2].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 2979 "xfst-parser.cc"
    break;

  case 60: /* COMMAND: SHOW NAMETOKEN END_COMMAND  */
#line 353 "xfst-parser.yy"
                                    {
            hfst::xfst::xfst_->show((yyvsp[-1].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 2988 "xfst-parser.cc"
    break;

  case 61: /* COMMAND: SHOW_ALL END_COMMAND  */
#line 357 "xfst-parser.yy"
                              {
            hfst::xfst::xfst_->show(); CHECK;
       }
#line 2996 "xfst-parser.cc"
    break;

  case 62: /* COMMAND: TWOSIDED_FLAGS END_COMMAND  */
#line 360 "xfst-parser.yy"
                                    {
            hfst::xfst::xfst_->twosided_flags(); CHECK;
       }
#line 3004 "xfst-parser.cc"
    break;

  case 63: /* COMMAND: TEST_EQ END_COMMAND  */
#line 364 "xfst-parser.yy"
                             {
            hfst::xfst::xfst_->test_eq(); CHECK;
       }
#line 3012 "xfst-parser.cc"
    break;

  case 64: /* COMMAND: TEST_FUNCT END_COMMAND  */
#line 367 "xfst-parser.yy"
                                {
            hfst::xfst::xfst_->test_funct(); CHECK;
       }
#line 3020 "xfst-parser.cc"
    break;

  case 65: /* COMMAND: TEST_ID END_COMMAND  */
#line 370 "xfst-parser.yy"
                             {
            hfst::xfst::xfst_->test_id(); CHECK;
       }
#line 3028 "xfst-parser.cc"
    break;

  case 66: /* COMMAND: TEST_INFINITELY_AMBIGUOUS  */
#line 373 "xfst-parser.yy"
                                   {
            hfst::xfst::xfst_->test_infinitely_ambiguous(); CHECK;
       }
#line 3036 "xfst-parser.cc"
    break;

  case 67: /* COMMAND: TEST_LOWER_BOUNDED END_COMMAND  */
#line 376 "xfst-parser.yy"
                                        {
            hfst::xfst::xfst_->test_lower_bounded(); CHECK;
       }
#line 3044 "xfst-parser.cc"
    break;

  case 68: /* COMMAND: TEST_LOWER_UNI END_COMMAND  */
#line 379 "xfst-parser.yy"
                                    {
            hfst::xfst::xfst_->test_lower_uni(); CHECK;
       }
#line 3052 "xfst-parser.cc"
    break;

  case 69: /* COMMAND: TEST_UPPER_BOUNDED END_COMMAND  */
#line 382 "xfst-parser.yy"
                                        {
            hfst::xfst::xfst_->test_upper_bounded(); CHECK;
       }
#line 3060 "xfst-parser.cc"
    break;

  case 70: /* COMMAND: TEST_UPPER_UNI END_COMMAND  */
#line 385 "xfst-parser.yy"
                                    {
            hfst::xfst::xfst_->test_upper_uni(); CHECK;
       }
#line 3068 "xfst-parser.cc"
    break;

  case 71: /* COMMAND: TEST_NONNULL END_COMMAND  */
#line 388 "xfst-parser.yy"
                                  {
            hfst::xfst::xfst_->test_nonnull(); CHECK;
       }
#line 3076 "xfst-parser.cc"
    break;

  case 72: /* COMMAND: TEST_NULL END_COMMAND  */
#line 391 "xfst-parser.yy"
                               {
            hfst::xfst::xfst_->test_null(); CHECK;
       }
#line 3084 "xfst-parser.cc"
    break;

  case 73: /* COMMAND: TEST_OVERLAP END_COMMAND  */
#line 394 "xfst-parser.yy"
                                  {
            hfst::xfst::xfst_->test_overlap(); CHECK;
       }
#line 3092 "xfst-parser.cc"
    break;

  case 74: /* COMMAND: TEST_SUBLANGUAGE END_COMMAND  */
#line 397 "xfst-parser.yy"
                                      {
            hfst::xfst::xfst_->test_sublanguage(); CHECK;
       }
#line 3100 "xfst-parser.cc"
    break;

  case 75: /* COMMAND: TEST_UNAMBIGUOUS END_COMMAND  */
#line 400 "xfst-parser.yy"
                                      {
            hfst::xfst::xfst_->test_unambiguous(); CHECK;
       }
#line 3108 "xfst-parser.cc"
    break;

  case 76: /* COMMAND: ASSERT TEST_EQ END_COMMAND  */
#line 404 "xfst-parser.yy"
                                    {
            hfst::xfst::xfst_->test_eq(true); CHECK;
       }
#line 3116 "xfst-parser.cc"
    break;

  case 77: /* COMMAND: ASSERT TEST_FUNCT END_COMMAND  */
#line 407 "xfst-parser.yy"
                                       {
            hfst::xfst::xfst_->test_funct(true); CHECK;
       }
#line 3124 "xfst-parser.cc"
    break;

  case 78: /* COMMAND: ASSERT TEST_ID END_COMMAND  */
#line 410 "xfst-parser.yy"
                                    {
            hfst::xfst::xfst_->test_id(true); CHECK;
       }
#line 3132 "xfst-parser.cc"
    break;

  case 79: /* COMMAND: ASSERT TEST_LOWER_BOUNDED END_COMMAND  */
#line 413 "xfst-parser.yy"
                                               {
            hfst::xfst::xfst_->test_lower_bounded(true); CHECK;
       }
#line 3140 "xfst-parser.cc"
    break;

  case 80: /* COMMAND: ASSERT TEST_LOWER_UNI END_COMMAND  */
#line 416 "xfst-parser.yy"
                                           {
            hfst::xfst::xfst_->test_lower_uni(true); CHECK;
       }
#line 3148 "xfst-parser.cc"
    break;

  case 81: /* COMMAND: ASSERT TEST_UPPER_BOUNDED END_COMMAND  */
#line 419 "xfst-parser.yy"
                                               {
            hfst::xfst::xfst_->test_upper_bounded(true); CHECK;
       }
#line 3156 "xfst-parser.cc"
    break;

  case 82: /* COMMAND: ASSERT TEST_UPPER_UNI END_COMMAND  */
#line 422 "xfst-parser.yy"
                                           {
            hfst::xfst::xfst_->test_upper_uni(true); CHECK;
       }
#line 3164 "xfst-parser.cc"
    break;

  case 83: /* COMMAND: ASSERT TEST_NONNULL END_COMMAND  */
#line 425 "xfst-parser.yy"
                                         {
            hfst::xfst::xfst_->test_nonnull(true); CHECK;
       }
#line 3172 "xfst-parser.cc"
    break;

  case 84: /* COMMAND: ASSERT TEST_NULL END_COMMAND  */
#line 428 "xfst-parser.yy"
                                      {
            hfst::xfst::xfst_->test_null(true); CHECK;
       }
#line 3180 "xfst-parser.cc"
    break;

  case 85: /* COMMAND: ASSERT TEST_OVERLAP END_COMMAND  */
#line 431 "xfst-parser.yy"
                                         {
            hfst::xfst::xfst_->test_overlap(true); CHECK;
       }
#line 3188 "xfst-parser.cc"
    break;

  case 86: /* COMMAND: ASSERT TEST_SUBLANGUAGE END_COMMAND  */
#line 434 "xfst-parser.yy"
                                             {
            hfst::xfst::xfst_->test_sublanguage(true); CHECK;
       }
#line 3196 "xfst-parser.cc"
    break;

  case 87: /* COMMAND: ASSERT TEST_UNAMBIGUOUS END_COMMAND  */
#line 437 "xfst-parser.yy"
                                             {
            hfst::xfst::xfst_->test_unambiguous(true); CHECK;
       }
#line 3204 "xfst-parser.cc"
    break;

  case 88: /* COMMAND: SUBSTITUTE_NAMED NAMETOKEN FOR NAMETOKEN END_COMMAND  */
#line 441 "xfst-parser.yy"
                                                              {
            hfst::xfst::xfst_->substitute_named((yyvsp[-3].name), (yyvsp[-1].name)); // TODO!
            free((yyvsp[-3].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 3214 "xfst-parser.cc"
    break;

  case 89: /* COMMAND: SUBSTITUTE_LABEL LABEL_LIST FOR LABEL END_COMMAND  */
#line 446 "xfst-parser.yy"
                                                           {
            hfst::xfst::xfst_->substitute_label((yyvsp[-3].text), (yyvsp[-1].text));
            free((yyvsp[-3].text));
            free((yyvsp[-1].text)); CHECK;
       }
#line 3224 "xfst-parser.cc"
    break;

  case 90: /* COMMAND: SUBSTITUTE_SYMBOL QUOTED_NAMETOKEN_LIST FOR NAMETOKEN END_COMMAND  */
#line 451 "xfst-parser.yy"
                                                                           {
            hfst::xfst::xfst_->substitute_symbol((yyvsp[-3].text), (yyvsp[-1].name));
            free((yyvsp[-3].text));
            free((yyvsp[-1].name)); CHECK;
       }
#line 3234 "xfst-parser.cc"
    break;

  case 91: /* COMMAND: PRINT_ALIASES REDIRECT_OUT END_COMMAND  */
#line 457 "xfst-parser.yy"
                                                {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_aliases(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 3248 "xfst-parser.cc"
    break;

  case 92: /* COMMAND: PRINT_ALIASES END_COMMAND  */
#line 466 "xfst-parser.yy"
                                   {
            hfst::xfst::xfst_->print_aliases(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3256 "xfst-parser.cc"
    break;

  case 93: /* COMMAND: PRINT_ARCCOUNT REDIRECT_OUT END_COMMAND  */
#line 469 "xfst-parser.yy"
                                                 {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_arc_count(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 3270 "xfst-parser.cc"
    break;

  case 94: /* COMMAND: PRINT_ARCCOUNT NAMETOKEN END_COMMAND  */
#line 478 "xfst-parser.yy"
                                              {
            if (strcmp((yyvsp[-1].name), "upper") && strcmp((yyvsp[-1].name), "lower"))
            {
                hxfsterror("should be upper or lower");
                free((yyvsp[-1].name));
                return EXIT_FAILURE;
            }
            hfst::xfst::xfst_->print_arc_count((yyvsp[-1].name), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name)); CHECK;
       }
#line 3285 "xfst-parser.cc"
    break;

  case 95: /* COMMAND: PRINT_ARCCOUNT END_COMMAND  */
#line 488 "xfst-parser.yy"
                                    {
            hfst::xfst::xfst_->print_arc_count(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3293 "xfst-parser.cc"
    break;

  case 96: /* COMMAND: PRINT_DEFINED REDIRECT_OUT END_COMMAND  */
#line 491 "xfst-parser.yy"
                                                {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
            {
	      std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_defined(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 3307 "xfst-parser.cc"
    break;

  case 97: /* COMMAND: PRINT_DEFINED END_COMMAND  */
#line 500 "xfst-parser.yy"
                                   {
            hfst::xfst::xfst_->print_defined(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3315 "xfst-parser.cc"
    break;

  case 98: /* COMMAND: PRINT_DIR GLOB REDIRECT_OUT END_COMMAND  */
#line 503 "xfst-parser.yy"
                                                 {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
            {
	      std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_dir((yyvsp[-2].name), &oss);
              oss.close();
	    }
            free((yyvsp[-1].file)); CHECK;
       }
#line 3329 "xfst-parser.cc"
    break;

  case 99: /* COMMAND: PRINT_DIR GLOB END_COMMAND  */
#line 512 "xfst-parser.yy"
                                    {
            hfst::xfst::xfst_->print_dir((yyvsp[-1].name), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name)); CHECK;
       }
#line 3338 "xfst-parser.cc"
    break;

  case 100: /* COMMAND: PRINT_DIR REDIRECT_OUT END_COMMAND  */
#line 516 "xfst-parser.yy"
                                            {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_dir("*", &oss);
              oss.close();
	    }
	    CHECK;
       }
#line 3352 "xfst-parser.cc"
    break;

  case 101: /* COMMAND: PRINT_DIR END_COMMAND  */
#line 525 "xfst-parser.yy"
                               {
            hfst::xfst::xfst_->print_dir("*", &hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3360 "xfst-parser.cc"
    break;

  case 102: /* COMMAND: PRINT_FILE_INFO REDIRECT_OUT END_COMMAND  */
#line 528 "xfst-parser.yy"
                                                  {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
            {
	      std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_file_info(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 3374 "xfst-parser.cc"
    break;

  case 103: /* COMMAND: PRINT_FILE_INFO END_COMMAND  */
#line 537 "xfst-parser.yy"
                                     {
            hfst::xfst::xfst_->print_file_info(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3382 "xfst-parser.cc"
    break;

  case 104: /* COMMAND: PRINT_FLAGS REDIRECT_OUT END_COMMAND  */
#line 540 "xfst-parser.yy"
                                              {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_flags(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 3396 "xfst-parser.cc"
    break;

  case 105: /* COMMAND: PRINT_FLAGS END_COMMAND  */
#line 549 "xfst-parser.yy"
                                 {
            hfst::xfst::xfst_->print_flags(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3404 "xfst-parser.cc"
    break;

  case 106: /* COMMAND: PRINT_LABELS NAMETOKEN END_COMMAND  */
#line 552 "xfst-parser.yy"
                                            {
            hfst::xfst::xfst_->print_labels((yyvsp[-1].name), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name)); CHECK;
       }
#line 3413 "xfst-parser.cc"
    break;

  case 107: /* COMMAND: PRINT_LABELS REDIRECT_OUT END_COMMAND  */
#line 556 "xfst-parser.yy"
                                               {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
            {
	      std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_labels(&oss);
              oss.close();
	      }
	      CHECK;
       }
#line 3427 "xfst-parser.cc"
    break;

  case 108: /* COMMAND: PRINT_LABELS END_COMMAND  */
#line 565 "xfst-parser.yy"
                                  {
            hfst::xfst::xfst_->print_labels(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3435 "xfst-parser.cc"
    break;

  case 109: /* COMMAND: PRINT_LABEL_COUNT REDIRECT_OUT END_COMMAND  */
#line 568 "xfst-parser.yy"
                                                    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_label_count(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 3449 "xfst-parser.cc"
    break;

  case 110: /* COMMAND: PRINT_LABEL_COUNT END_COMMAND  */
#line 577 "xfst-parser.yy"
                                       {
            hfst::xfst::xfst_->print_label_count(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3457 "xfst-parser.cc"
    break;

  case 111: /* COMMAND: PRINT_LIST NAMETOKEN REDIRECT_OUT END_COMMAND  */
#line 580 "xfst-parser.yy"
                                                       {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_list((yyvsp[-2].name), &oss);
              oss.close();
	    }
            free((yyvsp[-2].name)); CHECK;
       }
#line 3471 "xfst-parser.cc"
    break;

  case 112: /* COMMAND: PRINT_LIST NAMETOKEN END_COMMAND  */
#line 589 "xfst-parser.yy"
                                          {
            hfst::xfst::xfst_->print_list((yyvsp[-1].name), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name)); CHECK;
       }
#line 3480 "xfst-parser.cc"
    break;

  case 113: /* COMMAND: PRINT_LISTS REDIRECT_OUT END_COMMAND  */
#line 593 "xfst-parser.yy"
                                              {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
            {
	      std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_list(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 3494 "xfst-parser.cc"
    break;

  case 114: /* COMMAND: PRINT_LISTS END_COMMAND  */
#line 602 "xfst-parser.yy"
                                 {
            hfst::xfst::xfst_->print_list(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3502 "xfst-parser.cc"
    break;

  case 115: /* COMMAND: PRINT_LONGEST_STRING REDIRECT_OUT END_COMMAND  */
#line 605 "xfst-parser.yy"
                                                       {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_longest_string(&oss);
              //hfst::xfst::xfst_fclose(f, $2);
              oss.close();
	    }
            CHECK;
       }
#line 3517 "xfst-parser.cc"
    break;

  case 116: /* COMMAND: PRINT_LONGEST_STRING END_COMMAND  */
#line 615 "xfst-parser.yy"
                                          {
            //hfst::xfst::xfst_->print_longest_string(&hfst::xfst::xfst_->get_output_stream());
            hfst::xfst::xfst_->print_longest_string(&hfst::xfst::xfst_->get_output_stream());
            CHECK;
       }
#line 3527 "xfst-parser.cc"
    break;

  case 117: /* COMMAND: PRINT_LONGEST_STRING_SIZE REDIRECT_OUT END_COMMAND  */
#line 620 "xfst-parser.yy"
                                                            {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
            {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_longest_string_size(&oss);
              //hfst::xfst::xfst_fclose(f, $2);
              oss.close();
	    }
            CHECK;
       }
#line 3542 "xfst-parser.cc"
    break;

  case 118: /* COMMAND: PRINT_LONGEST_STRING_SIZE END_COMMAND  */
#line 630 "xfst-parser.yy"
                                               {
            //hfst::xfst::xfst_->print_longest_string_size(&hfst::xfst::xfst_->get_output_stream());
            hfst::xfst::xfst_->print_longest_string_size(&hfst::xfst::xfst_->get_output_stream());
            CHECK;
       }
#line 3552 "xfst-parser.cc"
    break;

  case 119: /* COMMAND: PRINT_NAME REDIRECT_OUT END_COMMAND  */
#line 635 "xfst-parser.yy"
                                             {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_name(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 3566 "xfst-parser.cc"
    break;

  case 120: /* COMMAND: PRINT_NAME END_COMMAND  */
#line 644 "xfst-parser.yy"
                                {
            hfst::xfst::xfst_->print_name(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3574 "xfst-parser.cc"
    break;

  case 121: /* COMMAND: PRINT_SHORTEST_STRING REDIRECT_OUT END_COMMAND  */
#line 647 "xfst-parser.yy"
                                                        {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_shortest_string(&oss);
              //hfst::xfst::xfst_fclose(f, $2);
              oss.close();
	    }
            CHECK;
       }
#line 3589 "xfst-parser.cc"
    break;

  case 122: /* COMMAND: PRINT_SHORTEST_STRING END_COMMAND  */
#line 657 "xfst-parser.yy"
                                           {
            //hfst::xfst::xfst_->print_shortest_string(&hfst::xfst::xfst_->get_output_stream());
            hfst::xfst::xfst_->print_shortest_string(&hfst::xfst::xfst_->get_output_stream());
            CHECK;
       }
#line 3599 "xfst-parser.cc"
    break;

  case 123: /* COMMAND: PRINT_SHORTEST_STRING_SIZE REDIRECT_OUT END_COMMAND  */
#line 662 "xfst-parser.yy"
                                                             {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_shortest_string_size(&oss);
              //hfst::xfst::xfst_fclose(f, $2);
              oss.close();
	    }
            CHECK;
       }
#line 3614 "xfst-parser.cc"
    break;

  case 124: /* COMMAND: PRINT_SHORTEST_STRING_SIZE END_COMMAND  */
#line 672 "xfst-parser.yy"
                                                {
            //hfst::xfst::xfst_->print_shortest_string_size(&hfst::xfst::xfst_->get_output_stream());
            hfst::xfst::xfst_->print_shortest_string_size(&hfst::xfst::xfst_->get_output_stream());
            CHECK;
       }
#line 3624 "xfst-parser.cc"
    break;

  case 125: /* COMMAND: PRINT_LOWER_WORDS NAMETOKEN NAMETOKEN END_COMMAND  */
#line 677 "xfst-parser.yy"
                                                           {
            hfst::xfst::xfst_->print_lower_words((yyvsp[-2].name), hfst::xfst::nametoken_to_number((yyvsp[-1].name)), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-2].name)); free((yyvsp[-1].name)); CHECK;
       }
#line 3633 "xfst-parser.cc"
    break;

  case 126: /* COMMAND: PRINT_LOWER_WORDS NAMETOKEN NAMETOKEN REDIRECT_OUT END_COMMAND  */
#line 681 "xfst-parser.yy"
                                                                        {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_lower_words((yyvsp[-3].name), hfst::xfst::nametoken_to_number((yyvsp[-2].name)), &oss);
              //hfst::xfst::xfst_fclose(f, $4);
              oss.close();
	    }
	    free((yyvsp[-3].name)); free((yyvsp[-2].name));
            CHECK;
       }
#line 3649 "xfst-parser.cc"
    break;

  case 127: /* COMMAND: PRINT_LOWER_WORDS NAMETOKEN END_COMMAND  */
#line 692 "xfst-parser.yy"
                                                 {
            int i = hfst::xfst::nametoken_to_number((yyvsp[-1].name));
            if (i != -1)
              hfst::xfst::xfst_->print_lower_words(NULL, i, &hfst::xfst::xfst_->get_output_stream());
            else
              hfst::xfst::xfst_->print_lower_words((yyvsp[-1].name), 0, &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name));
            CHECK;
       }
#line 3663 "xfst-parser.cc"
    break;

  case 128: /* COMMAND: PRINT_LOWER_WORDS END_COMMAND  */
#line 701 "xfst-parser.yy"
                                       {
            hfst::xfst::xfst_->print_lower_words(NULL, 0, &hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3671 "xfst-parser.cc"
    break;

  case 129: /* COMMAND: PRINT_LOWER_WORDS NAMETOKEN REDIRECT_OUT END_COMMAND  */
#line 704 "xfst-parser.yy"
                                                              {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              int i = hfst::xfst::nametoken_to_number((yyvsp[-2].name));
              if (i != -1)
                hfst::xfst::xfst_->print_lower_words(NULL, i, &oss);
              else
                hfst::xfst::xfst_->print_lower_words((yyvsp[-2].name), 0, &oss);
              //hfst::xfst::xfst_fclose(f, $3);
              oss.close();
	    }
            free((yyvsp[-2].name));
            CHECK;
       }
#line 3691 "xfst-parser.cc"
    break;

  case 130: /* COMMAND: PRINT_LOWER_WORDS REDIRECT_OUT END_COMMAND  */
#line 719 "xfst-parser.yy"
                                                    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_lower_words(NULL, 0, &oss);
              //hfst::xfst::xfst_fclose(f, $2);
              oss.close();
	    }
            CHECK;
       }
#line 3706 "xfst-parser.cc"
    break;

  case 131: /* COMMAND: PRINT_RANDOM_LOWER NAMETOKEN NAMETOKEN END_COMMAND  */
#line 729 "xfst-parser.yy"
                                                            {
            hfst::xfst::xfst_->print_random_lower((yyvsp[-2].name), hfst::xfst::nametoken_to_number((yyvsp[-1].name)), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-2].name)); free((yyvsp[-1].name)); CHECK;
       }
#line 3715 "xfst-parser.cc"
    break;

  case 132: /* COMMAND: PRINT_RANDOM_LOWER NAMETOKEN NAMETOKEN REDIRECT_OUT END_COMMAND  */
#line 733 "xfst-parser.yy"
                                                                         {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
            {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_random_lower((yyvsp[-3].name), hfst::xfst::nametoken_to_number((yyvsp[-2].name)), &oss);
              oss.close();
	      //hfst::xfst::xfst_fclose(f, $4);
	    }
	    free((yyvsp[-3].name)); free((yyvsp[-2].name));
            CHECK;
       }
#line 3731 "xfst-parser.cc"
    break;

  case 133: /* COMMAND: PRINT_RANDOM_LOWER NAMETOKEN END_COMMAND  */
#line 744 "xfst-parser.yy"
                                                  {
            int i = hfst::xfst::nametoken_to_number((yyvsp[-1].name));
            if (i != -1)
              hfst::xfst::xfst_->print_random_lower(NULL, i, &hfst::xfst::xfst_->get_output_stream());
            else
              hfst::xfst::xfst_->print_random_lower((yyvsp[-1].name), 15, &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name));CHECK;
       }
#line 3744 "xfst-parser.cc"
    break;

  case 134: /* COMMAND: PRINT_RANDOM_LOWER END_COMMAND  */
#line 752 "xfst-parser.yy"
                                        {
            hfst::xfst::xfst_->print_random_lower(NULL, 15, &hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3752 "xfst-parser.cc"
    break;

  case 135: /* COMMAND: PRINT_RANDOM_LOWER NAMETOKEN REDIRECT_OUT END_COMMAND  */
#line 755 "xfst-parser.yy"
                                                               {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              int i = hfst::xfst::nametoken_to_number((yyvsp[-2].name));
              if (i != -1)
                hfst::xfst::xfst_->print_random_lower(NULL, i, &oss);
              else
                hfst::xfst::xfst_->print_random_lower((yyvsp[-2].name), 15, &oss);
              //hfst::xfst::xfst_fclose(f, $3);
              oss.close();
	    }
            free((yyvsp[-2].name)); CHECK;
       }
#line 3771 "xfst-parser.cc"
    break;

  case 136: /* COMMAND: PRINT_RANDOM_LOWER REDIRECT_OUT END_COMMAND  */
#line 769 "xfst-parser.yy"
                                                     {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_random_lower(NULL, 15, &oss);
              //hfst::xfst::xfst_fclose(f, $2);
              oss.close();
	    }
            CHECK;
       }
#line 3786 "xfst-parser.cc"
    break;

  case 137: /* COMMAND: PRINT_UPPER_WORDS NAMETOKEN NAMETOKEN END_COMMAND  */
#line 779 "xfst-parser.yy"
                                                           {
            hfst::xfst::xfst_->print_upper_words((yyvsp[-2].name), hfst::xfst::nametoken_to_number((yyvsp[-1].name)), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-2].name)); CHECK;
       }
#line 3795 "xfst-parser.cc"
    break;

  case 138: /* COMMAND: PRINT_UPPER_WORDS NAMETOKEN NAMETOKEN REDIRECT_OUT END_COMMAND  */
#line 783 "xfst-parser.yy"
                                                                        {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_upper_words((yyvsp[-3].name), hfst::xfst::nametoken_to_number((yyvsp[-2].name)), &oss);
              //hfst::xfst::xfst_fclose(f, $4);
              oss.close();
	    }
	    free((yyvsp[-3].name)); free((yyvsp[-2].name));
            CHECK;
       }
#line 3811 "xfst-parser.cc"
    break;

  case 139: /* COMMAND: PRINT_UPPER_WORDS NAMETOKEN END_COMMAND  */
#line 794 "xfst-parser.yy"
                                                 {
            int i = hfst::xfst::nametoken_to_number((yyvsp[-1].name));
            if (i != -1)
              hfst::xfst::xfst_->print_upper_words(NULL, i, &hfst::xfst::xfst_->get_output_stream());
            else
              hfst::xfst::xfst_->print_upper_words((yyvsp[-1].name), 0, &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name)); CHECK;
       }
#line 3824 "xfst-parser.cc"
    break;

  case 140: /* COMMAND: PRINT_UPPER_WORDS END_COMMAND  */
#line 802 "xfst-parser.yy"
                                       {
            hfst::xfst::xfst_->print_upper_words(NULL, 0, &hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3832 "xfst-parser.cc"
    break;

  case 141: /* COMMAND: PRINT_UPPER_WORDS NAMETOKEN REDIRECT_OUT END_COMMAND  */
#line 805 "xfst-parser.yy"
                                                              {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              int i = hfst::xfst::nametoken_to_number((yyvsp[-2].name));
              if (i != -1)
                hfst::xfst::xfst_->print_upper_words(NULL, i, &oss);
              else
                hfst::xfst::xfst_->print_upper_words((yyvsp[-2].name), 0, &oss);
              oss.close();
	    }
            free((yyvsp[-2].name)); CHECK;
       }
#line 3850 "xfst-parser.cc"
    break;

  case 142: /* COMMAND: PRINT_UPPER_WORDS REDIRECT_OUT END_COMMAND  */
#line 818 "xfst-parser.yy"
                                                    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_upper_words(NULL, 0, &oss);
              oss.close();
	    }
            CHECK;
       }
#line 3864 "xfst-parser.cc"
    break;

  case 143: /* COMMAND: PRINT_RANDOM_UPPER NAMETOKEN NAMETOKEN END_COMMAND  */
#line 827 "xfst-parser.yy"
                                                            {
            hfst::xfst::xfst_->print_random_upper((yyvsp[-2].name), hfst::xfst::nametoken_to_number((yyvsp[-1].name)), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-2].name)); free((yyvsp[-1].name)); CHECK;
       }
#line 3873 "xfst-parser.cc"
    break;

  case 144: /* COMMAND: PRINT_RANDOM_UPPER NAMETOKEN NAMETOKEN REDIRECT_OUT END_COMMAND  */
#line 831 "xfst-parser.yy"
                                                                         {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_random_upper((yyvsp[-3].name), hfst::xfst::nametoken_to_number((yyvsp[-2].name)), &oss);
              oss.close();
	    }
	    free((yyvsp[-3].name)); free((yyvsp[-2].name));
            CHECK;
       }
#line 3888 "xfst-parser.cc"
    break;

  case 145: /* COMMAND: PRINT_RANDOM_UPPER NAMETOKEN END_COMMAND  */
#line 841 "xfst-parser.yy"
                                                  {
            int i = hfst::xfst::nametoken_to_number((yyvsp[-1].name));
            if (i != -1)
              hfst::xfst::xfst_->print_random_upper(NULL, i, &hfst::xfst::xfst_->get_output_stream());
            else
              hfst::xfst::xfst_->print_random_upper((yyvsp[-1].name), 15, &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name)); CHECK;
       }
#line 3901 "xfst-parser.cc"
    break;

  case 146: /* COMMAND: PRINT_RANDOM_UPPER END_COMMAND  */
#line 849 "xfst-parser.yy"
                                        {
            hfst::xfst::xfst_->print_random_upper(NULL, 15, &hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3909 "xfst-parser.cc"
    break;

  case 147: /* COMMAND: PRINT_RANDOM_UPPER NAMETOKEN REDIRECT_OUT END_COMMAND  */
#line 852 "xfst-parser.yy"
                                                               {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
            {
	      std::ofstream oss((yyvsp[-1].file));
              int i = hfst::xfst::nametoken_to_number((yyvsp[-2].name));
              if (i != -1)
                hfst::xfst::xfst_->print_random_upper(NULL, i, &oss);
              else
                hfst::xfst::xfst_->print_random_upper((yyvsp[-2].name), 15, &oss);
              oss.close();
	    }
            free((yyvsp[-2].name)); CHECK;
       }
#line 3927 "xfst-parser.cc"
    break;

  case 148: /* COMMAND: PRINT_RANDOM_UPPER REDIRECT_OUT END_COMMAND  */
#line 865 "xfst-parser.yy"
                                                     {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_random_upper(NULL, 15, &oss);
              oss.close();
	    }
            CHECK;
       }
#line 3941 "xfst-parser.cc"
    break;

  case 149: /* COMMAND: PRINT_WORDS NAMETOKEN NAMETOKEN END_COMMAND  */
#line 874 "xfst-parser.yy"
                                                     {
            hfst::xfst::xfst_->print_words((yyvsp[-2].name), hfst::xfst::nametoken_to_number((yyvsp[-1].name)), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-2].name)); free((yyvsp[-1].name)); CHECK;
       }
#line 3950 "xfst-parser.cc"
    break;

  case 150: /* COMMAND: PRINT_WORDS NAMETOKEN NAMETOKEN REDIRECT_OUT END_COMMAND  */
#line 878 "xfst-parser.yy"
                                                                  {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_words((yyvsp[-3].name), hfst::xfst::nametoken_to_number((yyvsp[-2].name)), &oss);
              oss.close();
	    }
	    free((yyvsp[-3].name)); free((yyvsp[-2].name));
            CHECK;
       }
#line 3965 "xfst-parser.cc"
    break;

  case 151: /* COMMAND: PRINT_WORDS NAMETOKEN END_COMMAND  */
#line 888 "xfst-parser.yy"
                                           {
            int i = hfst::xfst::nametoken_to_number((yyvsp[-1].name));
            if (i != -1)
              hfst::xfst::xfst_->print_words(NULL, i, &hfst::xfst::xfst_->get_output_stream());
            else
              hfst::xfst::xfst_->print_words((yyvsp[-1].name), 0, &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name)); CHECK;
       }
#line 3978 "xfst-parser.cc"
    break;

  case 152: /* COMMAND: PRINT_WORDS END_COMMAND  */
#line 896 "xfst-parser.yy"
                                 {
            hfst::xfst::xfst_->print_words(NULL, 0, &hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 3986 "xfst-parser.cc"
    break;

  case 153: /* COMMAND: PRINT_WORDS NAMETOKEN REDIRECT_OUT END_COMMAND  */
#line 899 "xfst-parser.yy"
                                                        {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              int i = hfst::xfst::nametoken_to_number((yyvsp[-2].name));
              if (i != -1)
                hfst::xfst::xfst_->print_words(NULL, i, &oss);
              else
                hfst::xfst::xfst_->print_words((yyvsp[-2].name), 0, &oss);
              oss.close();
	    }
            free((yyvsp[-2].name)); CHECK;
       }
#line 4004 "xfst-parser.cc"
    break;

  case 154: /* COMMAND: PRINT_WORDS REDIRECT_OUT END_COMMAND  */
#line 912 "xfst-parser.yy"
                                              {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_words(NULL, 0, &oss);
              oss.close();
	    }
            CHECK;
       }
#line 4018 "xfst-parser.cc"
    break;

  case 155: /* COMMAND: PRINT_RANDOM_WORDS NAMETOKEN NAMETOKEN END_COMMAND  */
#line 921 "xfst-parser.yy"
                                                            {
            hfst::xfst::xfst_->print_random_words((yyvsp[-2].name), hfst::xfst::nametoken_to_number((yyvsp[-1].name)), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-2].name)); free((yyvsp[-1].name)); CHECK;
       }
#line 4027 "xfst-parser.cc"
    break;

  case 156: /* COMMAND: PRINT_RANDOM_WORDS NAMETOKEN NAMETOKEN REDIRECT_OUT END_COMMAND  */
#line 925 "xfst-parser.yy"
                                                                         {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_random_words((yyvsp[-3].name), hfst::xfst::nametoken_to_number((yyvsp[-2].name)), &oss);
              oss.close();
	    }
	    free((yyvsp[-3].name)); free((yyvsp[-2].name));
            CHECK;
       }
#line 4042 "xfst-parser.cc"
    break;

  case 157: /* COMMAND: PRINT_RANDOM_WORDS NAMETOKEN END_COMMAND  */
#line 935 "xfst-parser.yy"
                                                  {
            int i = hfst::xfst::nametoken_to_number((yyvsp[-1].name));
            if (i != -1)
              hfst::xfst::xfst_->print_random_words(NULL, i, &hfst::xfst::xfst_->get_output_stream());
            else
              hfst::xfst::xfst_->print_random_words((yyvsp[-1].name), 15, &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name)); CHECK;
       }
#line 4055 "xfst-parser.cc"
    break;

  case 158: /* COMMAND: PRINT_RANDOM_WORDS END_COMMAND  */
#line 943 "xfst-parser.yy"
                                        {
            hfst::xfst::xfst_->print_random_words(NULL, 15, &hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 4063 "xfst-parser.cc"
    break;

  case 159: /* COMMAND: PRINT_RANDOM_WORDS NAMETOKEN REDIRECT_OUT END_COMMAND  */
#line 946 "xfst-parser.yy"
                                                               {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              int i = hfst::xfst::nametoken_to_number((yyvsp[-2].name));
              if (i != -1)
                hfst::xfst::xfst_->print_random_words(NULL, i, &oss);
              else
                hfst::xfst::xfst_->print_random_words((yyvsp[-2].name), 15, &oss);
            oss.close();
	    }
            free((yyvsp[-2].name)); CHECK;
       }
#line 4081 "xfst-parser.cc"
    break;

  case 160: /* COMMAND: PRINT_RANDOM_WORDS REDIRECT_OUT END_COMMAND  */
#line 959 "xfst-parser.yy"
                                                     {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_random_words(NULL, 15, &oss);
              oss.close();
	    }
            CHECK;
       }
#line 4095 "xfst-parser.cc"
    break;

  case 161: /* COMMAND: PRINT NAMETOKEN END_COMMAND  */
#line 968 "xfst-parser.yy"
                                     {
            hfst::xfst::xfst_->print_net((yyvsp[-1].name), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name)); CHECK;
       }
#line 4104 "xfst-parser.cc"
    break;

  case 162: /* COMMAND: PRINT REDIRECT_OUT END_COMMAND  */
#line 972 "xfst-parser.yy"
                                        {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_net(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 4118 "xfst-parser.cc"
    break;

  case 163: /* COMMAND: PRINT END_COMMAND  */
#line 981 "xfst-parser.yy"
                           {
            hfst::xfst::xfst_->print_net(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 4126 "xfst-parser.cc"
    break;

  case 164: /* COMMAND: PRINT_PROPS NAMETOKEN END_COMMAND  */
#line 984 "xfst-parser.yy"
                                           {
            hfst::xfst::xfst_->print_properties((yyvsp[-1].name), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name)); CHECK;
       }
#line 4135 "xfst-parser.cc"
    break;

  case 165: /* COMMAND: PRINT_PROPS END_COMMAND  */
#line 988 "xfst-parser.yy"
                                 {
            hfst::xfst::xfst_->print_properties(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 4143 "xfst-parser.cc"
    break;

  case 166: /* COMMAND: PRINT_PROPS REDIRECT_OUT END_COMMAND  */
#line 991 "xfst-parser.yy"
                                              {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_properties(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 4157 "xfst-parser.cc"
    break;

  case 167: /* COMMAND: PRINT_SIGMA NAMETOKEN END_COMMAND  */
#line 1000 "xfst-parser.yy"
                                           {
            hfst::xfst::xfst_->print_sigma((yyvsp[-1].name), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name)); CHECK;
       }
#line 4166 "xfst-parser.cc"
    break;

  case 168: /* COMMAND: PRINT_SIGMA REDIRECT_OUT END_COMMAND  */
#line 1004 "xfst-parser.yy"
                                              {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_sigma(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 4180 "xfst-parser.cc"
    break;

  case 169: /* COMMAND: PRINT_SIGMA END_COMMAND  */
#line 1013 "xfst-parser.yy"
                                 {
            hfst::xfst::xfst_->print_sigma(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 4188 "xfst-parser.cc"
    break;

  case 170: /* COMMAND: PRINT_SIGMA_COUNT REDIRECT_OUT END_COMMAND  */
#line 1016 "xfst-parser.yy"
                                                    {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_sigma_count(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 4202 "xfst-parser.cc"
    break;

  case 171: /* COMMAND: PRINT_SIGMA_COUNT END_COMMAND  */
#line 1025 "xfst-parser.yy"
                                       {
            hfst::xfst::xfst_->print_sigma_count(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 4210 "xfst-parser.cc"
    break;

  case 172: /* COMMAND: PRINT_SIGMA_WORD_COUNT NAMETOKEN END_COMMAND  */
#line 1028 "xfst-parser.yy"
                                                      {
            if (strcmp((yyvsp[-1].name), "upper") && strcmp((yyvsp[-1].name), "lower"))
            {
                free((yyvsp[-1].name));
                hxfsterror("must be upper or lower\n");
                return EXIT_FAILURE;
            }
            hfst::xfst::xfst_->print_sigma_word_count((yyvsp[-1].name), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name)); CHECK;
       }
#line 4225 "xfst-parser.cc"
    break;

  case 173: /* COMMAND: PRINT_SIGMA_WORD_COUNT REDIRECT_OUT END_COMMAND  */
#line 1038 "xfst-parser.yy"
                                                         {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_sigma_word_count(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 4239 "xfst-parser.cc"
    break;

  case 174: /* COMMAND: PRINT_SIGMA_WORD_COUNT END_COMMAND  */
#line 1047 "xfst-parser.yy"
                                            {
            hfst::xfst::xfst_->print_sigma_word_count(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 4247 "xfst-parser.cc"
    break;

  case 175: /* COMMAND: PRINT_SIZE NAMETOKEN END_COMMAND  */
#line 1050 "xfst-parser.yy"
                                          {
            hfst::xfst::xfst_->print_size((yyvsp[-1].name), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name)); CHECK;
       }
#line 4256 "xfst-parser.cc"
    break;

  case 176: /* COMMAND: PRINT_SIZE REDIRECT_OUT END_COMMAND  */
#line 1054 "xfst-parser.yy"
                                             {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_size(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 4270 "xfst-parser.cc"
    break;

  case 177: /* COMMAND: PRINT_SIZE END_COMMAND  */
#line 1063 "xfst-parser.yy"
                                {
            hfst::xfst::xfst_->print_size(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 4278 "xfst-parser.cc"
    break;

  case 178: /* COMMAND: PRINT_STACK REDIRECT_OUT END_COMMAND  */
#line 1066 "xfst-parser.yy"
                                              {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_stack(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 4292 "xfst-parser.cc"
    break;

  case 179: /* COMMAND: PRINT_STACK END_COMMAND  */
#line 1075 "xfst-parser.yy"
                                 {
            hfst::xfst::xfst_->print_stack(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 4300 "xfst-parser.cc"
    break;

  case 180: /* COMMAND: PRINT_LABELMAPS REDIRECT_OUT END_COMMAND  */
#line 1078 "xfst-parser.yy"
                                                  {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->print_labelmaps(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 4314 "xfst-parser.cc"
    break;

  case 181: /* COMMAND: SAVE_DOT NAMETOKEN END_COMMAND  */
#line 1088 "xfst-parser.yy"
                                        {
            hfst::xfst::xfst_->write_dot((yyvsp[-1].name), &hfst::xfst::xfst_->get_output_stream());
            free((yyvsp[-1].name)); CHECK;
       }
#line 4323 "xfst-parser.cc"
    break;

  case 182: /* COMMAND: SAVE_DOT REDIRECT_OUT END_COMMAND  */
#line 1092 "xfst-parser.yy"
                                           {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->write_dot(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 4337 "xfst-parser.cc"
    break;

  case 183: /* COMMAND: SAVE_DOT END_COMMAND  */
#line 1101 "xfst-parser.yy"
                              {
            hfst::xfst::xfst_->write_dot(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 4345 "xfst-parser.cc"
    break;

  case 184: /* COMMAND: SAVE_DEFINITION NAMETOKEN LEFT_PAREN REDIRECT_OUT END_COMMAND  */
#line 1104 "xfst-parser.yy"
                                                                       {
            hfst::xfst::xfst_->write_function((yyvsp[-3].name), (yyvsp[-1].file));
            free((yyvsp[-3].name)); CHECK;
       }
#line 4354 "xfst-parser.cc"
    break;

  case 185: /* COMMAND: SAVE_DEFINITION NAMETOKEN LEFT_PAREN END_COMMAND  */
#line 1108 "xfst-parser.yy"
                                                          {
            hfst::xfst::xfst_->write_function((yyvsp[-2].name), 0);
            free((yyvsp[-2].name)); CHECK;
       }
#line 4363 "xfst-parser.cc"
    break;

  case 186: /* COMMAND: SAVE_DEFINITION NAMETOKEN REDIRECT_OUT END_COMMAND  */
#line 1112 "xfst-parser.yy"
                                                            {
            hfst::xfst::xfst_->write_definition((yyvsp[-2].name), (yyvsp[-1].file));
            free((yyvsp[-2].name)); CHECK;
       }
#line 4372 "xfst-parser.cc"
    break;

  case 187: /* COMMAND: SAVE_DEFINITION NAMETOKEN END_COMMAND  */
#line 1116 "xfst-parser.yy"
                                               {
            hfst::xfst::xfst_->write_definition((yyvsp[-1].name), 0);
            free((yyvsp[-1].name)); CHECK;
       }
#line 4381 "xfst-parser.cc"
    break;

  case 188: /* COMMAND: SAVE_DEFINITIONS REDIRECT_OUT END_COMMAND  */
#line 1120 "xfst-parser.yy"
                                                   {
            hfst::xfst::xfst_->write_definitions((yyvsp[-1].file)); CHECK;
       }
#line 4389 "xfst-parser.cc"
    break;

  case 189: /* COMMAND: SAVE_DEFINITIONS END_COMMAND  */
#line 1123 "xfst-parser.yy"
                                      {
            hfst::xfst::xfst_->write_definitions(0); CHECK;
       }
#line 4397 "xfst-parser.cc"
    break;

  case 190: /* COMMAND: SAVE_STACK NAMETOKEN END_COMMAND  */
#line 1126 "xfst-parser.yy"
                                          {
            hfst::xfst::xfst_->write_stack((yyvsp[-1].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 4406 "xfst-parser.cc"
    break;

  case 191: /* COMMAND: SAVE_PROLOG REDIRECT_OUT END_COMMAND  */
#line 1130 "xfst-parser.yy"
                                              {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->write_prolog(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 4420 "xfst-parser.cc"
    break;

  case 192: /* COMMAND: SAVE_PROLOG NAMETOKEN END_COMMAND  */
#line 1139 "xfst-parser.yy"
                                           {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].name)))
	    {
              std::ofstream oss((yyvsp[-1].name));
              hfst::xfst::xfst_->write_prolog(&oss);
              oss.close();
	    }
	    free((yyvsp[-1].name)); CHECK;
       }
#line 4434 "xfst-parser.cc"
    break;

  case 193: /* COMMAND: SAVE_PROLOG END_COMMAND  */
#line 1148 "xfst-parser.yy"
                                 {
            hfst::xfst::xfst_->write_prolog(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 4442 "xfst-parser.cc"
    break;

  case 194: /* COMMAND: SAVE_SPACED REDIRECT_OUT END_COMMAND  */
#line 1151 "xfst-parser.yy"
                                              {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->write_spaced(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 4456 "xfst-parser.cc"
    break;

  case 195: /* COMMAND: SAVE_SPACED END_COMMAND  */
#line 1160 "xfst-parser.yy"
                                 {
            hfst::xfst::xfst_->write_spaced(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 4464 "xfst-parser.cc"
    break;

  case 196: /* COMMAND: SAVE_TEXT REDIRECT_OUT END_COMMAND  */
#line 1163 "xfst-parser.yy"
                                            {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->write_text(&oss);
              oss.close();
	    }
	    CHECK;
       }
#line 4478 "xfst-parser.cc"
    break;

  case 197: /* COMMAND: SAVE_TEXT END_COMMAND  */
#line 1172 "xfst-parser.yy"
                               {
            hfst::xfst::xfst_->write_text(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 4486 "xfst-parser.cc"
    break;

  case 198: /* COMMAND: READ_PROPS REDIRECT_IN END_COMMAND  */
#line 1176 "xfst-parser.yy"
                                            {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              FILE * f = hfst::xfst::xfst_->xfst_fopen((yyvsp[-1].file), "r"); CHECK;
              hfst::xfst::xfst_->read_props(f);
              hfst::xfst::xfst_->xfst_fclose(f, (yyvsp[-1].file));
	    }
	    CHECK;
       }
#line 4500 "xfst-parser.cc"
    break;

  case 199: /* COMMAND: READ_PROPS END_COMMAND  */
#line 1185 "xfst-parser.yy"
                                {
            hfst::xfst::xfst_->read_props(stdin); CHECK;
       }
#line 4508 "xfst-parser.cc"
    break;

  case 200: /* COMMAND: READ_PROLOG NAMETOKEN END_COMMAND  */
#line 1188 "xfst-parser.yy"
                                           {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].name)))
	    {
              FILE * f = hfst::xfst::xfst_->xfst_fopen((yyvsp[-1].name), "r"); CHECK;
              hfst::xfst::xfst_->read_prolog(f);
              hfst::xfst::xfst_->xfst_fclose(f, (yyvsp[-1].name));
	    }
	    free((yyvsp[-1].name)); CHECK;
       }
#line 4522 "xfst-parser.cc"
    break;

  case 201: /* COMMAND: READ_PROLOG END_COMMAND  */
#line 1197 "xfst-parser.yy"
                                 {
            hfst::xfst::xfst_->read_prolog(stdin); CHECK;
       }
#line 4530 "xfst-parser.cc"
    break;

  case 202: /* COMMAND: READ_REGEX REGEX  */
#line 1200 "xfst-parser.yy"
                          {
            hfst::xfst::xfst_->read_regex((yyvsp[0].text));
            free((yyvsp[0].text)); CHECK;
       }
#line 4539 "xfst-parser.cc"
    break;

  case 203: /* COMMAND: READ_REGEX REDIRECT_IN END_COMMAND  */
#line 1204 "xfst-parser.yy"
                                            {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              FILE * f = hfst::xfst::xfst_->xfst_fopen((yyvsp[-1].file), "r"); CHECK;
              hfst::xfst::xfst_->read_regex(f);
              hfst::xfst::xfst_->xfst_fclose(f, (yyvsp[-1].file));
	    }
	    CHECK;
       }
#line 4553 "xfst-parser.cc"
    break;

  case 204: /* COMMAND: READ_REGEX NAMETOKEN_LIST SEMICOLON END_COMMAND  */
#line 1213 "xfst-parser.yy"
                                                         {
            hfst::xfst::xfst_->read_regex((yyvsp[-2].text));
            free((yyvsp[-2].text)); CHECK;
       }
#line 4562 "xfst-parser.cc"
    break;

  case 205: /* COMMAND: READ_SPACED REDIRECT_IN END_COMMAND  */
#line 1217 "xfst-parser.yy"
                                             {
            hfst::xfst::xfst_->read_spaced_from_file((yyvsp[-1].file));
            free((yyvsp[-1].file)); CHECK;
       }
#line 4571 "xfst-parser.cc"
    break;

  case 206: /* COMMAND: READ_SPACED NAMETOKEN END_COMMAND  */
#line 1221 "xfst-parser.yy"
                                           {
            hfst::xfst::xfst_->read_spaced_from_file((yyvsp[-1].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 4580 "xfst-parser.cc"
    break;

  case 207: /* COMMAND: READ_SPACED NAMETOKEN_LIST CTRLD  */
#line 1225 "xfst-parser.yy"
                                          {
            hfst::xfst::xfst_->read_spaced((yyvsp[-1].text));
            free((yyvsp[-1].text)); CHECK;
       }
#line 4589 "xfst-parser.cc"
    break;

  case 208: /* COMMAND: READ_TEXT REDIRECT_IN END_COMMAND  */
#line 1229 "xfst-parser.yy"
                                           {
            hfst::xfst::xfst_->read_text_from_file((yyvsp[-1].file));
            free((yyvsp[-1].file)); CHECK;
       }
#line 4598 "xfst-parser.cc"
    break;

  case 209: /* COMMAND: READ_TEXT NAMETOKEN END_COMMAND  */
#line 1233 "xfst-parser.yy"
                                         {
            hfst::xfst::xfst_->read_text_from_file((yyvsp[-1].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 4607 "xfst-parser.cc"
    break;

  case 210: /* COMMAND: READ_TEXT NAMETOKEN_LIST CTRLD  */
#line 1237 "xfst-parser.yy"
                                        {
            hfst::xfst::xfst_->read_text((yyvsp[-1].text));
            free((yyvsp[-1].text)); CHECK;
       }
#line 4616 "xfst-parser.cc"
    break;

  case 211: /* COMMAND: READ_LEXC NAMETOKEN END_COMMAND  */
#line 1241 "xfst-parser.yy"
                                         {
            hfst::xfst::xfst_->read_lexc_from_file((yyvsp[-1].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 4625 "xfst-parser.cc"
    break;

  case 212: /* COMMAND: READ_LEXC NAMETOKEN SEMICOLON END_COMMAND  */
#line 1245 "xfst-parser.yy"
                                                   {
            hfst::xfst::xfst_->read_lexc_from_file((yyvsp[-2].name));
            free((yyvsp[-2].name)); CHECK;
       }
#line 4634 "xfst-parser.cc"
    break;

  case 213: /* COMMAND: READ_LEXC NAMETOKEN_LIST CTRLD  */
#line 1249 "xfst-parser.yy"
                                        {
            hfst::xfst::xfst_->read_lexc_from_file(""); free((yyvsp[-1].text)); CHECK;
       }
#line 4642 "xfst-parser.cc"
    break;

  case 214: /* COMMAND: READ_ATT NAMETOKEN END_COMMAND  */
#line 1252 "xfst-parser.yy"
                                        {
            hfst::xfst::xfst_->read_att_from_file((yyvsp[-1].name));
            free((yyvsp[-1].name)); CHECK;
       }
#line 4651 "xfst-parser.cc"
    break;

  case 215: /* COMMAND: WRITE_ATT END_COMMAND  */
#line 1256 "xfst-parser.yy"
                               {
            hfst::xfst::xfst_->write_att(&hfst::xfst::xfst_->get_output_stream()); CHECK;
       }
#line 4659 "xfst-parser.cc"
    break;

  case 216: /* COMMAND: WRITE_ATT REDIRECT_OUT END_COMMAND  */
#line 1259 "xfst-parser.yy"
                                            {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].file)))
	    {
              std::ofstream oss((yyvsp[-1].file));
              hfst::xfst::xfst_->write_att(&oss);
              oss.close();
	    }
            free((yyvsp[-1].file)); CHECK;
       }
#line 4673 "xfst-parser.cc"
    break;

  case 217: /* COMMAND: WRITE_ATT NAMETOKEN END_COMMAND  */
#line 1268 "xfst-parser.yy"
                                         {
            if (hfst::xfst::xfst_->check_filename((yyvsp[-1].name)))
	    {
              std::ofstream oss((yyvsp[-1].name));
              hfst::xfst::xfst_->write_att(&oss);
              oss.close();
	    }
            free((yyvsp[-1].name)); CHECK;
       }
#line 4687 "xfst-parser.cc"
    break;

  case 218: /* COMMAND: WRITE_ATT NAMETOKEN NAMETOKEN NAMETOKEN END_COMMAND  */
#line 1277 "xfst-parser.yy"
                                                             {
            // todo: handle input and output symbol tables
	    if (hfst::xfst::xfst_->check_filename((yyvsp[-3].name)))
	    {
              std::ofstream oss((yyvsp[-3].name));
              hfst::xfst::xfst_->write_att(&oss);
              oss.close();
	    }
            free((yyvsp[-3].name)); free((yyvsp[-2].name)); free((yyvsp[-1].name)); CHECK;
       }
#line 4702 "xfst-parser.cc"
    break;

  case 219: /* COMMAND: CLEANUP END_COMMAND  */
#line 1288 "xfst-parser.yy"
                             {
            hfst::xfst::xfst_->cleanup_net(); CHECK;
       }
#line 4710 "xfst-parser.cc"
    break;

  case 220: /* COMMAND: COMPLETE END_COMMAND  */
#line 1291 "xfst-parser.yy"
                              {
            hfst::xfst::xfst_->complete_net(); CHECK;
       }
#line 4718 "xfst-parser.cc"
    break;

  case 221: /* COMMAND: COMPOSE END_COMMAND  */
#line 1294 "xfst-parser.yy"
                             {
            hfst::xfst::xfst_->compose_net(); CHECK;
       }
#line 4726 "xfst-parser.cc"
    break;

  case 222: /* COMMAND: CONCATENATE END_COMMAND  */
#line 1297 "xfst-parser.yy"
                                 {
            hfst::xfst::xfst_->concatenate_net(); CHECK;
       }
#line 4734 "xfst-parser.cc"
    break;

  case 223: /* COMMAND: MINUS END_COMMAND  */
#line 1300 "xfst-parser.yy"
                           {
            hfst::xfst::xfst_->minus_net(); CHECK;
       }
#line 4742 "xfst-parser.cc"
    break;

  case 224: /* COMMAND: CROSSPRODUCT END_COMMAND  */
#line 1303 "xfst-parser.yy"
                                  {
            hfst::xfst::xfst_->crossproduct_net(); CHECK;
       }
#line 4750 "xfst-parser.cc"
    break;

  case 225: /* COMMAND: MINIMIZE END_COMMAND  */
#line 1306 "xfst-parser.yy"
                              {
            hfst::xfst::xfst_->minimize_net(); CHECK;
       }
#line 4758 "xfst-parser.cc"
    break;

  case 226: /* COMMAND: DETERMINIZE END_COMMAND  */
#line 1309 "xfst-parser.yy"
                                 {
            hfst::xfst::xfst_->determinize_net(); CHECK;
       }
#line 4766 "xfst-parser.cc"
    break;

  case 227: /* COMMAND: EPSILON_REMOVE END_COMMAND  */
#line 1312 "xfst-parser.yy"
                                    {
            hfst::xfst::xfst_->epsilon_remove_net(); CHECK;
       }
#line 4774 "xfst-parser.cc"
    break;

  case 228: /* COMMAND: PRUNE_NET END_COMMAND  */
#line 1315 "xfst-parser.yy"
                               {
            hfst::xfst::xfst_->prune_net(); CHECK;
       }
#line 4782 "xfst-parser.cc"
    break;

  case 229: /* COMMAND: XFST_IGNORE END_COMMAND  */
#line 1318 "xfst-parser.yy"
                                 {
            hfst::xfst::xfst_->ignore_net(); CHECK;
       }
#line 4790 "xfst-parser.cc"
    break;

  case 230: /* COMMAND: INTERSECT END_COMMAND  */
#line 1321 "xfst-parser.yy"
                               {
            hfst::xfst::xfst_->intersect_net(); CHECK;
       }
#line 4798 "xfst-parser.cc"
    break;

  case 231: /* COMMAND: INSPECT END_COMMAND  */
#line 1324 "xfst-parser.yy"
                             {
            hfst::xfst::xfst_->inspect_net(); CHECK;
       }
#line 4806 "xfst-parser.cc"
    break;

  case 232: /* COMMAND: INVERT END_COMMAND  */
#line 1327 "xfst-parser.yy"
                            {
            hfst::xfst::xfst_->invert_net(); CHECK;
       }
#line 4814 "xfst-parser.cc"
    break;

  case 233: /* COMMAND: LOWER_SIDE END_COMMAND  */
#line 1330 "xfst-parser.yy"
                                {
            hfst::xfst::xfst_->lower_side_net(); CHECK;
       }
#line 4822 "xfst-parser.cc"
    break;

  case 234: /* COMMAND: UPPER_SIDE END_COMMAND  */
#line 1333 "xfst-parser.yy"
                                {
            hfst::xfst::xfst_->upper_side_net(); CHECK;
       }
#line 4830 "xfst-parser.cc"
    break;

  case 235: /* COMMAND: NEGATE END_COMMAND  */
#line 1336 "xfst-parser.yy"
                            {
            hfst::xfst::xfst_->negate_net(); CHECK;
       }
#line 4838 "xfst-parser.cc"
    break;

  case 236: /* COMMAND: ONE_PLUS END_COMMAND  */
#line 1339 "xfst-parser.yy"
                              {
            hfst::xfst::xfst_->one_plus_net(); CHECK;
       }
#line 4846 "xfst-parser.cc"
    break;

  case 237: /* COMMAND: ZERO_PLUS END_COMMAND  */
#line 1342 "xfst-parser.yy"
                               {
            hfst::xfst::xfst_->zero_plus_net(); CHECK;
       }
#line 4854 "xfst-parser.cc"
    break;

  case 238: /* COMMAND: XFST_OPTIONAL END_COMMAND  */
#line 1345 "xfst-parser.yy"
                                   {
            hfst::xfst::xfst_->optional_net(); CHECK;
       }
#line 4862 "xfst-parser.cc"
    break;

  case 239: /* COMMAND: REVERSE END_COMMAND  */
#line 1348 "xfst-parser.yy"
                             {
            hfst::xfst::xfst_->reverse_net(); CHECK;
       }
#line 4870 "xfst-parser.cc"
    break;

  case 240: /* COMMAND: SHUFFLE END_COMMAND  */
#line 1351 "xfst-parser.yy"
                             {
            hfst::xfst::xfst_->shuffle_net(); CHECK;
       }
#line 4878 "xfst-parser.cc"
    break;

  case 241: /* COMMAND: SIGMA END_COMMAND  */
#line 1354 "xfst-parser.yy"
                           {
            hfst::xfst::xfst_->sigma_net(); CHECK;
       }
#line 4886 "xfst-parser.cc"
    break;

  case 242: /* COMMAND: SORT END_COMMAND  */
#line 1357 "xfst-parser.yy"
                          {
            hfst::xfst::xfst_->sort_net(); CHECK;
       }
#line 4894 "xfst-parser.cc"
    break;

  case 243: /* COMMAND: SUBSTRING END_COMMAND  */
#line 1360 "xfst-parser.yy"
                               {
            hfst::xfst::xfst_->substring_net(); CHECK;
       }
#line 4902 "xfst-parser.cc"
    break;

  case 244: /* COMMAND: UNION END_COMMAND  */
#line 1363 "xfst-parser.yy"
                           {
            hfst::xfst::xfst_->union_net(); CHECK;
       }
#line 4910 "xfst-parser.cc"
    break;

  case 245: /* COMMAND: LABEL_NET END_COMMAND  */
#line 1366 "xfst-parser.yy"
                               {
            hfst::xfst::xfst_->label_net(); CHECK;
       }
#line 4918 "xfst-parser.cc"
    break;

  case 246: /* COMMAND: COMPILE_REPLACE_LOWER END_COMMAND  */
#line 1369 "xfst-parser.yy"
                                           {
            hfst::xfst::xfst_->compile_replace_lower_net(); CHECK;
       }
#line 4926 "xfst-parser.cc"
    break;

  case 247: /* COMMAND: COMPILE_REPLACE_UPPER END_COMMAND  */
#line 1372 "xfst-parser.yy"
                                           {
            hfst::xfst::xfst_->compile_replace_upper_net(); CHECK;
       }
#line 4934 "xfst-parser.cc"
    break;

  case 248: /* COMMAND: END_COMMAND  */
#line 1375 "xfst-parser.yy"
                     {
            hfst::xfst::xfst_->prompt(); CHECK;
       }
#line 4942 "xfst-parser.cc"
    break;

  case 249: /* COMMAND: NAMETOKEN END_COMMAND  */
#line 1378 "xfst-parser.yy"
                               {
            if ( hfst::xfst::xfst_->unknown_command((yyvsp[-1].name)) != 0)
              {
                hxfsterror("Command not recognized.\n");
                free((yyvsp[-1].name));
                YYABORT;
              }
            free((yyvsp[-1].name));
       }
#line 4956 "xfst-parser.cc"
    break;

  case 252: /* COMMAND_SEQUENCE: COMMAND_SEQUENCE NAMETOKEN  */
#line 1391 "xfst-parser.yy"
                                             {
                    (yyval.text) = static_cast<char*>(malloc(sizeof(char)*strlen((yyvsp[-1].text))+strlen((yyvsp[0].name))+2));
                    char* r = (yyval.text);
                    char* s = (yyvsp[-1].text);
                    while (*s != '\0')
                    {
                        *r = *s;
                        r++;
                        s++;
                    }
                    *r = ' ';
                    r++;
                    s = (yyvsp[0].name);
                    while (*s != '\0')
                    {
                        *r = *s;
                        r++;
                        s++;
                    }
                    *r = '\0';
                    free((yyvsp[0].name));
                }
#line 4983 "xfst-parser.cc"
    break;

  case 253: /* COMMAND_SEQUENCE: COMMAND_SEQUENCE SEMICOLON  */
#line 1413 "xfst-parser.yy"
                                             {
                    (yyval.text) = (yyvsp[-1].text);
                }
#line 4991 "xfst-parser.cc"
    break;

  case 254: /* COMMAND_SEQUENCE: NAMETOKEN  */
#line 1416 "xfst-parser.yy"
                            {
                    (yyval.text) = (yyvsp[0].name);
                }
#line 4999 "xfst-parser.cc"
    break;

  case 255: /* NAMETOKEN_LIST: NAMETOKEN_LIST NAMETOKEN  */
#line 1421 "xfst-parser.yy"
                                         {
                (yyval.text) = static_cast<char*>(malloc(sizeof(char)*strlen((yyvsp[-1].text))+strlen((yyvsp[0].name))+2));
                char* s = (yyvsp[-1].text);
                char* r = (yyval.text);
                while (*s != '\0')
                {
                    *r = *s;
                    r++;
                    s++;
                }
                *r = ' ';
                r++;
                s = (yyvsp[0].name);
                while (*s != '\0')
                {
                    *r = *s;
                    r++;
                    s++;
                }
                *r = '\0';
                free((yyvsp[-1].text)); free((yyvsp[0].name));
             }
#line 5026 "xfst-parser.cc"
    break;

  case 256: /* NAMETOKEN_LIST: NAMETOKEN  */
#line 1443 "xfst-parser.yy"
                         {
                (yyval.text) = (yyvsp[0].name);
             }
#line 5034 "xfst-parser.cc"
    break;

  case 257: /* QUOTED_NAMETOKEN_LIST: QUOTED_NAMETOKEN_LIST NAMETOKEN  */
#line 1448 "xfst-parser.yy"
                                                       {
                (yyval.text) = static_cast<char*>(malloc(sizeof(char)*strlen((yyvsp[-1].text))+strlen((yyvsp[0].name))+4));
                char* s = (yyvsp[-1].text);
                char* r = (yyval.text);
                while (*s != '\0')
                {
                    *r = *s;
                    r++;
                    s++;
                }
                *r = ' ';
                r++;
                s = (yyvsp[0].name);
                *r = '"';
                r++;
                while (*s != '\0')
                {
                    *r = *s;
                    r++;
                    s++;
                }
                *r = '"';
                r++;
                *r = '\0';
                free((yyvsp[-1].text)); free((yyvsp[0].name));
             }
#line 5065 "xfst-parser.cc"
    break;

  case 258: /* QUOTED_NAMETOKEN_LIST: NAMETOKEN  */
#line 1474 "xfst-parser.yy"
                         {
                (yyval.text) = static_cast<char*>(malloc(sizeof(char)*strlen((yyvsp[0].name))+3));
                char* s = (yyvsp[0].name);
                char* r = (yyval.text);
                *r = '"';
                r++;
                while (*s != '\0')
                {
                    *r = *s;
                    r++;
                    s++;
                }
                *r = '"';
                r++;
                *r = '\0';
                free((yyvsp[0].name));
             }
#line 5087 "xfst-parser.cc"
    break;

  case 259: /* LABEL: NAMETOKEN COLON NAMETOKEN  */
#line 1493 "xfst-parser.yy"
                                 {
                (yyval.text) = strdup((std::string((yyvsp[-2].name)) + std::string(":") + std::string((yyvsp[0].name))).c_str());
                free((yyvsp[-2].name)); free((yyvsp[0].name));
                }
#line 5096 "xfst-parser.cc"
    break;

  case 260: /* LABEL: NAMETOKEN  */
#line 1497 "xfst-parser.yy"
                            {
                (yyval.text) = (yyvsp[0].name);
                }
#line 5104 "xfst-parser.cc"
    break;

  case 261: /* LABEL_LIST: LABEL_LIST LABEL  */
#line 1502 "xfst-parser.yy"
                             {
                (yyval.text) = static_cast<char*>(malloc(sizeof(char)*strlen((yyvsp[-1].text))+strlen((yyvsp[0].text))+2));
                char* s = (yyvsp[-1].text);
                char* r = (yyval.text);
                while (*s != '\0')
                {
                    *r = *s;
                    r++;
                    s++;
                }
                *r = ' ';
                r++;
                s = (yyvsp[0].text);
                while (*s != '\0')
                {
                    *r = *s;
                    r++;
                    s++;
                }
                *r = '\0';
                free((yyvsp[-1].text)); free((yyvsp[0].text));
             }
#line 5131 "xfst-parser.cc"
    break;

  case 262: /* LABEL_LIST: LABEL  */
#line 1524 "xfst-parser.yy"
                     {
                (yyval.text) = (yyvsp[0].text);
             }
#line 5139 "xfst-parser.cc"
    break;


#line 5143 "xfst-parser.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken, &yylloc};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 1528 "xfst-parser.yy"


// oblig. declarations
extern FILE* hxfstin;
int hxfstparse(void);

// gah, bison/flex error mechanism here
void
hxfsterror(const char* text)
{
    hfst::xfst::xfst_->error() << text << std::endl;
    hfst::xfst::xfst_->flush(&hfst::xfst::xfst_->error());
    //fprintf(stderr,  "%s\n", text);
}


// vim: set ft=yacc:
